//
//  ConnectionManager.m
//  MenuMenu
//
//  Created by Sławek Derwisz on 26.02.2013.
//  Copyright (c) 2013 Pawel Ferens. All rights reserved.
//

#import "ConnectionManager.h"


#define kBgQueue dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0)
@implementation ConnectionManager{
    NSString *currentDistrictname;
    
}

@synthesize cities;
@synthesize districts;
@synthesize restaurants;
@synthesize restaurantsData;
@synthesize receivedData;

static ConnectionManager *instance =nil;

+(ConnectionManager *)getInstance
{
    @synchronized(self)
    {
        if(instance==nil){
            instance= [ConnectionManager new];
            instance.restaurants = [[NSMutableArray alloc] init];
            instance.districts = [[NSMutableArray alloc] init];
            instance.cities = [[NSMutableArray alloc] init];
          
        }
    }
    return instance;
}



-(void)findNearbyWith: (float)lat andWith: (float)lon{
    NSLog(@"start pobierania");
    NSString *Url = [NSString stringWithFormat:@"http://menumenu-cms.appspot.com/GetRestaurantsInArea?token=a1b2c3&lat=%f&lon=%f", lat, lon];
    
    bool productionState = [[[NSBundle mainBundle] objectForInfoDictionaryKey:@"Production"] boolValue];
    NSLog(@"production: %d", productionState);
    NSString *production;
    if(productionState == YES)
        production = @"true";
    else
        production = @"false";
    
    NSString *statistics = @"application";
    
    if(production !=nil)
        Url = [Url stringByAppendingFormat:@"&production=%@", production];
    else
        Url = [Url stringByAppendingString:@"&production=true"];
    
    if(statistics != nil)
        Url = [Url stringByAppendingFormat:@"&statistics=%@", statistics];
    else
        Url = [Url stringByAppendingString:@"&statistics=application"];
    
    NSLog(@"production: %@", Url);
    
  /*  NSData *nearbyData = [self getDataFromURL:Url];
    
    [self performSelectorOnMainThread:@selector(fetchRestaurants:)
                           withObject:nearbyData waitUntilDone:NO];*/
    [self getDataFromUrlNew:Url];
}


-(void)getRestaurantsWithCityId: (NSString*)restId
{
    //test server
    //    NSString* urlString=@"http://menutester.appspot.com/getRestaurants?token=a1b2c3&cityId=179545518";
    
    NSString* urlString=[NSString stringWithFormat:@"http://menumenu-cms.appspot.com/getRestaurants?token=a1b2c3&cityId=%@&statistics=application",restId];
//    dispatch_async(kBgQueue, ^{
//        restaurantsData = [NSData dataWithContentsOfURL:
//                           [NSURL URLWithString:urlString]];
//        [self performSelectorOnMainThread:@selector(fetchRestaurants:)
//                               withObject:restaurantsData waitUntilDone:NO];
//    });
    NSURLRequest *req = [NSURLRequest requestWithURL:[NSURL URLWithString:urlString]];
    [self appdelegate].connection = [[NSURLConnection alloc] initWithRequest:req delegate:self];
}


-(void)fetchRestaurants:(NSData *)responseData
{
    NSLog(@"parsowanie rozpoczete");
    LocationManager *locationManager = [LocationManager getInstance];
    if(responseData)
    {
        [locationManager getLocation];
        [restaurants removeAllObjects];
        NSError* error;
        NSArray *restaurantsArray = [NSJSONSerialization
                                     JSONObjectWithData:responseData
                                     options:kNilOptions
                                     error:&error];
        if ([restaurantsArray isEqual: nil] || [restaurantsArray count]==0) {
            NSLog(@"brak restauracji");
            UIAlertView *alert = [[UIAlertView alloc] initWithTitle:NSLocalizedString(@"Empty", nil)
                                                            message:NSLocalizedString(@"NoRestaurant", nil)
                                                           delegate:self
                                                  cancelButtonTitle:NSLocalizedString(@"OkButton", nil)
                                                  otherButtonTitles:nil, nil];
            alert.tag=0;
            [alert show];
            return;
        
        }
        currentDistrictname=nil;
        
        
        int bound = restaurantsArray.count;
     //   if([self appdelegate].isFindNearby)bound = 15;
        
        for(int i=0;i<bound;i++)
        {
            NSDictionary* restaurantData=[restaurantsArray objectAtIndex:i];
            Restaurant*temporaryRestaurant=[[Restaurant alloc]init];
            temporaryRestaurant.logoImage=[restaurantData objectForKey:@"logoImage"];
            temporaryRestaurant.profileDateCreate=[restaurantData objectForKey:@"profileDateCreate"];
            temporaryRestaurant.profileImage=[restaurantData objectForKey:@"profileImage"];
//            temporaryRestaurant.menuImageDefault=[restaurantData objectForKey:@"menuImageDefault"];
            
            NSNumber * isSuccessNumber = (NSNumber *)[restaurantData objectForKey: @"menuImageDefault"];
            if(isSuccessNumber && [isSuccessNumber boolValue] == YES)
            {
                // this is the YES case
                temporaryRestaurant.menuImageDefault=YES;
            }
            else{
                temporaryRestaurant.menuImageDefault=NO;
            }
            temporaryRestaurant.menuDateCreate=[restaurantData objectForKey:@"menuDateCreate"];
            temporaryRestaurant.lng=[restaurantData objectForKey:@"lng"];
            temporaryRestaurant.logoDateCreate=[restaurantData objectForKey:@"logoDateCreate"];
            temporaryRestaurant.menuImageScreenSize=[restaurantData objectForKey:@"menuImageScreenSize"];
            temporaryRestaurant.city=[restaurantData objectForKey:@"city"];
            temporaryRestaurant.restaurantId=[restaurantData objectForKey:@"restaurantId"];
            temporaryRestaurant.address=[restaurantData objectForKey:@"address"];
            temporaryRestaurant.menuImage=[restaurantData objectForKey:@"menuImage"];
            temporaryRestaurant.name=[restaurantData objectForKey:@"name"];
            temporaryRestaurant.menuImageScaleSize=[restaurantData objectForKey:@"menuImageScaleSize"];
            temporaryRestaurant.district=[restaurantData objectForKey:@"district"];
            temporaryRestaurant.lat=[restaurantData objectForKey:@"lat"];
            temporaryRestaurant.phoneRestaurant=[restaurantData objectForKey:@"phoneRestaurant"];
            temporaryRestaurant.LOGOSize = CGSizeMake([[restaurantData objectForKey:@"LOGOWidth"] floatValue], [[restaurantData objectForKey:@"LOGOHeight"] floatValue]);
            temporaryRestaurant.MENUSize = CGSizeMake([[restaurantData objectForKey:@"MENUWidth"] floatValue], [[restaurantData objectForKey:@"MENUHeight"] floatValue]);
            temporaryRestaurant.openHours = [NSMutableArray arrayWithArray:[restaurantData objectForKey:@"openHours"]];
            
            if([self appdelegate].isFindNearby
               && locationManager.la !=0
               && locationManager.lo !=0){
                
                [locationManager getLocation];
                temporaryRestaurant.distance = [locationManager calculateDistanceWithLatA:temporaryRestaurant.lat.floatValue
                                                                                   andLoA:temporaryRestaurant.lng.floatValue
                                                                                  andLatB:locationManager.la
                                                                                   andLoB:locationManager.lo];
                NSLog(@"distance2=%f",temporaryRestaurant.distance);
            }
            else{
                temporaryRestaurant.distance = -1;
            }
            
            [restaurants addObject:temporaryRestaurant];
            if(i==restaurantsArray.count-1){
                currentDistrictname=temporaryRestaurant.city;
            }
        }
        if(![self appdelegate].isFindNearby){
            
            NSString *cachesPath = [NSSearchPathForDirectoriesInDomains(NSCachesDirectory, NSUserDomainMask, YES) lastObject];
            NSString *cacheFilePath = [cachesPath stringByAppendingPathComponent:[currentDistrictname stringByAppendingPathExtension:@"json"]];
            
            bool fileExists = [[NSFileManager defaultManager] fileExistsAtPath:cacheFilePath];
            
            if(fileExists){
                
                NSData *cachedJsonData = [[NSData alloc]initWithContentsOfFile: cacheFilePath];
                if(cachedJsonData != nil){
                    _cachedRestaurants = [NSJSONSerialization
                                          JSONObjectWithData: cachedJsonData
                                          options:kNilOptions
                                          error:&error];
                }
                else{
                    _cachedRestaurants = nil;
                }
            }
            else{
                [responseData writeToFile:cacheFilePath atomically:YES];
                NSArray *directoryContent = [[NSFileManager defaultManager] directoryContentsAtPath: cachesPath];
                NSLog(@"files: %@", directoryContent);
            }
            
        }
        else{
            NSSortDescriptor *valueDescriptor = [[NSSortDescriptor alloc] initWithKey:@"distance" ascending:YES];
            NSArray * descriptors = [NSArray arrayWithObject:valueDescriptor];
            NSArray * sortedArray = [restaurants sortedArrayUsingDescriptors:descriptors];
            restaurants = [NSMutableArray arrayWithArray: sortedArray];
        }
        
        
        NSString *notificationName = @"restaurantsLoaded";
        [[NSNotificationCenter defaultCenter] postNotificationName:notificationName object:nil ];
    }
}

- (void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex {
    if(alertView.tag == 0){
        NSLog(@"notify");
        NSString *notificationName = @"goBack";
        [[NSNotificationCenter defaultCenter] postNotificationName:notificationName object:nil ];
    }
}

-(void)updateDistrictJSON{
    NSString *cachesPath = [NSSearchPathForDirectoriesInDomains(NSCachesDirectory, NSUserDomainMask, YES) lastObject];
    NSString *cacheFilePath = [cachesPath stringByAppendingPathComponent:[currentDistrictname stringByAppendingPathExtension:@"json"]];
    [restaurantsData writeToFile:cacheFilePath atomically:YES];
    NSLog(@"district JSON updated");
}

//parse methods

-(void)getDistrictsFromCountry: (NSString*) country{
    
    
    NSLog(@"start pobierania");
    NSString *districtsUrl = @"http://menumenu-cms.appspot.com/getCities?token=a1b2c3";
    
    bool productionState = [[[NSBundle mainBundle] objectForInfoDictionaryKey:@"Production"] boolValue];
    //   NSLog(@"production: %d", productionState);
    NSString *production;
    if(productionState == YES)
        production = @"true";
    else
        production = @"false";
    
    NSString *statistics = @"application";
    
    if(production !=nil)
        districtsUrl = [districtsUrl stringByAppendingFormat:@"&production=%@", production];
    else
        districtsUrl = [districtsUrl stringByAppendingString:@"&production=true"];
    
    if(statistics != nil)
        districtsUrl = [districtsUrl stringByAppendingFormat:@"&statistics=%@", statistics];
    else
        districtsUrl = [districtsUrl stringByAppendingString:@"&statistics=application"];
    
    if(country != nil)
        districtsUrl = [districtsUrl stringByAppendingFormat:@"&country=%@", country];
    
    //   NSLog(@"production: %@", districtsUrl);
    
    NSData *districtData = [self getDataFromURL:districtsUrl];
    
    //parse to districts objects
    [self parseToDistrictsFromData:districtData];
    
    //save data
    NSString *districtsCacheDir = [[NSSearchPathForDirectoriesInDomains(NSCachesDirectory, NSUserDomainMask, YES) lastObject] stringByAppendingPathComponent:@"districts"];
    NSString *filePath = [districtsCacheDir stringByAppendingPathComponent: @"districts.json"];
    
    
    [districtData writeToFile:filePath atomically:YES];
    
    
    
}

-(void)parseToDistrictsFromData: (NSData*)districtData{
    NSLog(@"district parsing");
    NSError* error;
    NSArray* districtsArray = [NSJSONSerialization
                               JSONObjectWithData:districtData
                               options:kNilOptions
                               error:&error];
    NSLog(@"test");
    
    NSArray* localDistricts=nil;
    NSString *districtsCacheDir = [[NSSearchPathForDirectoriesInDomains(NSCachesDirectory, NSUserDomainMask, YES) lastObject] stringByAppendingPathComponent:@"districts"];
    
    
    NSString *filePath = [districtsCacheDir stringByAppendingPathComponent: @"districts.json"];
    
    bool fileExists = [[NSFileManager defaultManager] fileExistsAtPath:filePath];
    
    if(fileExists){
        NSData *jsonData = [[NSData alloc]initWithContentsOfFile: filePath];
        
        localDistricts = [NSJSONSerialization
                          JSONObjectWithData: jsonData
                          options:kNilOptions
                          error:&error];
    }
    for(int i=0;i<[districtsArray count];i++){
        NSDictionary* districtsDictionary=[districtsArray objectAtIndex:i];
        District* district=[[District alloc]init];
        district.districtId=[districtsDictionary objectForKey:@"id"];
        district.districtImageURL=[districtsDictionary objectForKey:@"districtImageURL"];
        district.name=[districtsDictionary objectForKey:@"name"];
        district.country=[districtsDictionary objectForKey:@"country"];
        [districts addObject:district];
        
        if(localDistricts == nil
           || localDistricts.count == 0
           || localDistricts.count < districtsArray.count
           || ![district.districtImageURL isEqualToString:[[localDistricts objectAtIndex:i] objectForKey:@"districtImageURL"]]){
            NSLog(@"new image on server, downloading");
            if([district districtImageURL] != nil && ![[district districtImageURL] isEqualToString:@""]){
                NSString *localFileName = [districtsCacheDir  stringByAppendingPathComponent:[district districtId]];
                [self downloadImageFromURL:[district districtImageURL] andSaveAs:localFileName];
            }
        }
    }
    NSLog(@"%d districts loaded",[districtsArray count]);

    
    NSString *notificationName = @"DistrictLoaded";
    [[NSNotificationCenter defaultCenter] postNotificationName:notificationName object:nil ];
}

//Connection methods
-(NSData*)getDataFromURL: (NSString*) url{
    NSData* data = [NSData dataWithContentsOfURL:[NSURL URLWithString:url]];
    if(data == nil){
        data = [NSData dataWithBytes:[@"[]" UTF8String] length:[@"[]" lengthOfBytesUsingEncoding:NSUTF8StringEncoding]];
    }
    return data;
}

-(void)getDataFromUrlNew:(NSString*)url
{
    NSURLRequest *req = [NSURLRequest requestWithURL:[NSURL URLWithString:url]];
    [self appdelegate].connection = [[NSURLConnection alloc] initWithRequest:req delegate:self];
    
    
    
}
-(void) downloadImageFromURL:(NSString *)fileURL andSaveAs: (NSString*) fileName{
    NSLog(@"Downloading... ");
    NSLog(@"from path: %@", fileURL);
    NSData * data = [NSData dataWithContentsOfURL:[NSURL URLWithString:fileURL]];
    if(data != nil){
        UIImage *image =[[UIImage alloc]initWithData:data];
        [UIImageJPEGRepresentation(image, 1.0) writeToFile:[fileName stringByAppendingPathExtension:@"jpg"] options:nil error:nil];
    }
    else
        NSLog(@"Empty file");
}

- (AppDelegate *) appdelegate {
    return (AppDelegate *)[[UIApplication sharedApplication] delegate];
}


	
- (void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response
{
    receivedData=[[NSMutableData alloc]init];
 
//    NSLog(@"dziala");
    
}
- (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data
{
//    NSLog(@"received data");
    [receivedData appendData:data];
}
- (void)connection:(NSURLConnection *)connection
  didFailWithError:(NSError *)error
{

    NSLog(@"Connection failed! Error - %@ %@",
          [error localizedDescription],
          [[error userInfo] objectForKey:NSURLErrorFailingURLStringErrorKey]);
}
- (void)connectionDidFinishLoading:(NSURLConnection *)connection
{
      NSLog(@"parsowanie");
   [self fetchRestaurants:self.receivedData];
  
}
@end
