//
//  DistrictsController.m
//  MenuMenu
//
//  Created by Sławek Derwisz on 26.02.2013.
//  Copyright (c) 2013 Pawel Ferens. All rights reserved.
//

#import "DistrictsViewController.h"

@implementation DistrictsViewController

@synthesize scrollView;
@synthesize pageControl;
@synthesize loadingView;
@synthesize spinner;
@synthesize currentDistrictButton;
@synthesize isInfoShowed;
@synthesize back;

#define IS_WIDESCREEN ( fabs( ( double )[ [ UIScreen mainScreen ] bounds ].size.height - ( double )568 ) < DBL_EPSILON )

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

-(void)viewWillAppear:(BOOL)animated{
    [[UIDevice currentDevice] setOrientation:UIInterfaceOrientationPortrait];
    [self appdelegate].rotateToLandScape=NO;
    [menu setAlpha:0];
    isInfoShowed=NO;
    [back setAlpha:0.0f];
   // [self willRotateToInterfaceOrientation: [UIDevice currentDevice].orientation duration:0];
  
    
}
- (AppDelegate *) appdelegate {
    return (AppDelegate *)[[UIApplication sharedApplication] delegate];
}
-(void)handleTap:(UITapGestureRecognizer*)sender
{
    [UIView beginAnimations:nil context:nil];
    [UIView setAnimationDuration:0.3];
    [UIView setAnimationCurve:UIViewAnimationCurveEaseOut];
    [loadingView setAlpha:0.0f];
    
    [spinner stopAnimating];
    [UIView commitAnimations];
    [[self appdelegate].connection cancel];
    [currentDistrictButton setUserInteractionEnabled:YES];
}
- (void)viewDidLoad
{
    [super viewDidLoad];
    
    
    
   
    
    spinner=[[UIActivityIndicatorView alloc]initWithActivityIndicatorStyle:UIActivityIndicatorViewStyleWhiteLarge];
    [spinner setCenter:CGPointMake(self.view.frame.size.width/2, self.view.frame.size.height/2)];
    
    [loadingView addSubview:spinner];
    [loadingView setUserInteractionEnabled:YES];
    
    UITapGestureRecognizer * gesture=[[UITapGestureRecognizer alloc]initWithTarget:self action:@selector(handleTap:)];
    [loadingView addGestureRecognizer:gesture];
    NSString *notificationName = @"restaurantsLoaded";
    [[NSNotificationCenter defaultCenter]
     addObserver:self
     selector:@selector(loadScrollView:)
     name:notificationName
     object:nil];
    
    NSString *notificationName2 = @"currentLocationSet";
    [[NSNotificationCenter defaultCenter]
     addObserver:self
     selector:@selector(find)
     name:notificationName2
     object:nil];
    
    connManager = [ConnectionManager getInstance];
	kNumberOfPages = [connManager districts].count;
    items = [[NSMutableArray alloc]initWithObjects:@"Find nearby", nil];
    for(int i=0; i<kNumberOfPages; i++){
        [items addObject: [[connManager.districts objectAtIndex:i] name]];
    }
    [self initPages];
}
-(void)loadScrollView:(NSNotification *)notification{
    [self animateViewChange];
    [UIView beginAnimations:nil context:nil];
    [UIView setAnimationDuration:0.5];
    [UIView setAnimationCurve:UIViewAnimationCurveEaseOut];
    [loadingView setAlpha:0.0f];
    
    [spinner stopAnimating];
    [UIView commitAnimations];
    [currentDistrictButton setUserInteractionEnabled:YES];
    [[self navigationController] pushViewController: mainScrollView animated:NO];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)scrollViewDidScroll:(UIScrollView *)sender {
    if (!pageControlUsed) {
        // Update the page when more than 50% of the previous/next page is visible
        CGFloat pageWidth = self.scrollView.frame.size.width;
        int page = floor((self.scrollView.contentOffset.x - pageWidth / 2) / pageWidth) + 1;
        self.pageControl.currentPage = page;
    }
}

- (void)scrollViewWillBeginDragging:(UIScrollView *)scrollView {
    pageControlUsed = NO;
}

- (void)scrollViewDidEndDecelerating:(UIScrollView *)scrollView {
    pageControlUsed = NO;
}



- (IBAction)changePage {
    CGRect frame;
    frame.origin.x = self.scrollView.frame.size.width * self.pageControl.currentPage;
    frame.origin.y = 0;
    frame.size = self.scrollView.frame.size;
    [self.scrollView scrollRectToVisible:frame animated:YES];
    pageControlUsed = YES;
}

-(IBAction)showMenu:(UIButton*)sender{
    if((int)[sender tag] == 0){
        
        [menuButton setTag:1];
        
        [UIView beginAnimations:nil context:nil];
        [UIView setAnimationDuration:0.5];
        [UIView setAnimationCurve:UIViewAnimationCurveEaseOut];
        [menu setAlpha:1];
        [UIView commitAnimations];
        
    }
    else if((int)[sender tag] == 1){
        [menuButton setTag:0];
        [UIView beginAnimations:nil context:nil];
        [UIView setAnimationDuration:0.5];
        [UIView setAnimationCurve:UIViewAnimationCurveEaseOut];
        [menu setAlpha:0];
        [UIView commitAnimations];
    }
}

-(IBAction)goToDistrict: (UIButton*)sender{
    if ([self connected]) {
        [self appdelegate].isFindNearby = NO;
        [self appdelegate].isLocationForFindNearby = NO;
        currentDistrictButton=sender;
        [sender setUserInteractionEnabled:NO];
        [self loadDistrictById: [NSString stringWithFormat:@"%d",(int)[sender tag]]];
    }
    else
    {
        UIAlertView*alert=[[UIAlertView alloc]initWithTitle:@""
                                                    message:NSLocalizedString(@"NoNetwork", nil)
                                                   delegate:self
                                          cancelButtonTitle:NSLocalizedString(@"OkButton", nil)
                                          otherButtonTitles:nil  , nil];
        [alert show];
    }
    
}
-(void)find{
    NSLog(@"Notification method");
    ConnectionManager* connectionManager=[ConnectionManager getInstance];
    LocationManager * locationManager=[LocationManager getInstance];
    [self appdelegate].isLocationForFindNearby= NO;
    [connectionManager findNearbyWith:locationManager.la andWith:locationManager.lo];
}
-(void)loadDistrictById: (NSString*) districtId{
    [connManager.restaurants removeAllObjects];
    [self appdelegate].isRestaurantsScreenLoaded=NO;
    [self appdelegate].isHorizontalScreenLoaded=NO;
    mainScrollView=[self.storyboard instantiateViewControllerWithIdentifier:@"mainScrollView" ];
    mainScrollView.districtId = districtId;
    //mainScrollView.isFindNearby = NO;
    [self appdelegate].isFindNearby = NO;
    
    
    ConnectionManager* connectionManager=[ConnectionManager getInstance];
    LocationManager * locationManager=[LocationManager getInstance];
    if(![self appdelegate].isFindNearby){
        [connectionManager getRestaurantsWithCityId:districtId];
        [UIView beginAnimations:nil context:nil];
        [UIView setAnimationDuration:0.5];
        [UIView setAnimationCurve:UIViewAnimationCurveEaseOut];
        [loadingView setAlpha:0.5f];
        [UIView commitAnimations];
        [spinner startAnimating];
        
    }
    else{
        NSLog(@"Localization service status:");
        if ([CLLocationManager locationServicesEnabled]) {
            NSLog(@"Localization service enable.");
            [locationManager getLocation];
        }
        else
        {
            NSLog(@"Localization service disable.");
           
            UIAlertView*alert=[[UIAlertView alloc]initWithTitle:@""
                                                        message:NSLocalizedString(@"TurnOnLocation", nil)
                                                       delegate:self
                                              cancelButtonTitle:NSLocalizedString(@"OkButton", nil)
                                              otherButtonTitles:nil  , nil];
            
            alert.tag=1;
            [alert show];
        }
        
    }

}

-(void)initPages{
    UIColor *redColor = [UIColor colorWithRed:(179/255.f) green:(15/255.f) blue:(16/255.f) alpha:1.f];
    
    NSMutableArray *districts = [ConnectionManager getInstance].districts;
    
    [pageControl setNumberOfPages:kNumberOfPages+1];
    pageControlUsed = NO;
    
    NSDate *currentDateTime = [NSDate date];
    NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
    [dateFormatter setDateFormat:@"yyyy-MM-dd HH:mm"];
    NSString *dateInString = [dateFormatter stringFromDate:currentDateTime];
    
    CGRect pageFrame = CGRectMake(0,
                                  0,
                                  self.view.frame.size.width,
                                  self.view.frame.size.height-(topBar.frame.size.height/2));
    
    
    
    //add 'find nearby' image
    
    UIView *firstPage = [[UIView alloc] initWithFrame:pageFrame];
    
    //NSString *documentsDirectory =[[NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES)objectAtIndex:0]stringByAppendingPathComponent:@"districts"];
    
    NSString *districtsCacheDir = [[NSSearchPathForDirectoriesInDomains(NSCachesDirectory, NSUserDomainMask, YES) lastObject] stringByAppendingPathComponent:@"districts"];
    
    UIImage *bgImage = [UIImage imageNamed:@"photoslider.png"];
    
    CGRect bgFrame = CGRectMake((pageFrame.size.width-bgImage.size.width)/2,
                                ((self.scrollView.frame.size.height - bgImage.size.height+(topBar.frame.size.height-10))/2),
                                bgImage.size.width,
                                bgImage.size.height);
    
    CGRect nameLabelFrame = CGRectMake(bgFrame.origin.x,
                                       bgFrame.origin.y,
                                       bgFrame.size.width,
                                       48);
    
    CGRect updateTextFrame = CGRectMake(bgFrame.origin.x,
                                        bgFrame.origin.y + bgFrame.size.height-32,
                                        bgFrame.size.width,
                                        32);
    
    UIImageView *bgImageView = [[UIImageView alloc] initWithFrame:bgFrame];
    [bgImageView setContentMode:UIViewContentModeCenter];
    [bgImageView setImage:bgImage];
    
    UILabel *title = [[UILabel alloc]initWithFrame:nameLabelFrame];
    [title setTextColor:redColor];
    [title setFont:[UIFont fontWithName:@"Futura" size:18]];
    [title setBackgroundColor:[UIColor colorWithWhite:1 alpha:0]];
    [title setText: NSLocalizedString(@"FindNearby", nil)];
    [title setTextAlignment:NSTextAlignmentCenter];
    
    UILabel *update = [[UILabel alloc]initWithFrame:updateTextFrame];
    [update setTextColor:redColor];
    [update setFont:[UIFont fontWithName:@"Futura" size:11]];
    [update setBackgroundColor:[UIColor colorWithWhite:1 alpha:0]];
    [update setTextAlignment:NSTextAlignmentCenter];
    [update setText:[NSString stringWithFormat: @"%@ %@",
                     NSLocalizedString(@"Updated", nil),
                     dateInString]];
    
    UIButton *firstPageImage = [[UIButton alloc] initWithFrame:bgFrame];
    [firstPageImage setContentMode: UIViewContentModeCenter];
    [firstPageImage setImage: [UIImage imageNamed:@"map.png"] forState:UIControlStateNormal];
    [firstPageImage setTag:0];
    [firstPageImage addTarget:self action:@selector(goToFindNearby) forControlEvents:UIControlEventTouchUpInside];
    firstPageImage.adjustsImageWhenHighlighted=NO;
    [firstPage addSubview: bgImageView];
    [firstPage addSubview: firstPageImage];
    [firstPage addSubview:title];
    [firstPage addSubview:update];
    [self.scrollView addSubview:firstPage];
    
    //add other pages
    
    NSLog(@"page count: %d", kNumberOfPages);
    for(int i=0; i<kNumberOfPages; i++){
        
        pageFrame.origin.x = self.scrollView.frame.size.width * (i+1);
        pageFrame.origin.y = 0;
        pageFrame.size = self.scrollView.frame.size;
        
        UIView *page = [[UIView alloc] initWithFrame:pageFrame];
        [page setContentMode: UIViewContentModeCenter];
        UIImageView *bgImageView = [[UIImageView alloc] initWithFrame:bgFrame];
        [bgImageView setContentMode:UIViewContentModeCenter];
        [bgImageView setImage:bgImage];
        
        // loading content
        UILabel *districtName = [[UILabel alloc]initWithFrame:nameLabelFrame];
        [districtName setTextColor:redColor];
        [districtName setFont:[UIFont fontWithName:@"Futura" size:18]];
        [districtName setBackgroundColor:[UIColor colorWithWhite:1 alpha:0]];
        [districtName setText: [[districts objectAtIndex:i] name]];
        [districtName setTextAlignment:NSTextAlignmentCenter];
        
        UILabel *updateText = [[UILabel alloc]initWithFrame:updateTextFrame];
        [updateText setTextColor:redColor];
        [updateText setFont:[UIFont fontWithName:@"Futura" size:11]];
        [updateText setBackgroundColor:[UIColor colorWithWhite:1 alpha:0]];
        [updateText setTextAlignment:NSTextAlignmentCenter];
        [updateText setText:[NSString stringWithFormat: @"%@ %@",
                             NSLocalizedString(@"Updated", nil),
                             dateInString]];
        
        UIButton *districtImage = [[UIButton alloc] initWithFrame:
                                   CGRectMake(bgFrame.origin.x + 1,
                                              bgFrame.origin.y + 48,
                                              bgFrame.size.width-2,
                                              bgFrame.size.height-48-32)];
        
        
        NSString *filePath = [districtsCacheDir stringByAppendingPathComponent: [[[districts objectAtIndex:i] districtId]stringByAppendingPathExtension:@"jpg"]];
        [districtImage setImage:[UIImage imageWithContentsOfFile:filePath] forState:UIControlStateNormal];
        [districtImage setContentMode:UIViewContentModeScaleToFill];
        [districtImage setTag: [[districts objectAtIndex:i]districtId].intValue];
        [districtImage addTarget:self action:@selector(goToDistrict:) forControlEvents:UIControlEventTouchUpInside];
        districtImage.adjustsImageWhenHighlighted=NO;
        [page addSubview: bgImageView];
        
        [page addSubview:districtImage];
        [page addSubview:districtName];
        [page addSubview:updateText];
        [self.scrollView addSubview:page];
        
    }
    
    self.scrollView.contentSize = CGSizeMake(self.scrollView.frame.size.width * (kNumberOfPages+1), self.scrollView.frame.size.height);
}
- (BOOL)connected
{
    Reachability *reachability = [Reachability reachabilityForInternetConnection];
    NetworkStatus networkStatus = [reachability currentReachabilityStatus];
    return !(networkStatus == NotReachable);
}
-(BOOL)isPad
{
#ifdef UI_USER_INTERFACE_IDIOM
    return UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad;
#endif
    return NO;
}
-(void)goToFindNearby{
    if ([self isPad]) {
        UIAlertView*alert=[[UIAlertView alloc]initWithTitle:@""
                                                    message:NSLocalizedString(@"Not supported on iPad yet. ", nil)
                                                   delegate:self
                                          cancelButtonTitle:NSLocalizedString(@"OkButton", nil)
                                          otherButtonTitles:nil  , nil];
        [alert show];
    }
    else
    {
    if ([self connected]) {
        
        
        if ( [CLLocationManager locationServicesEnabled]) {
            mainScrollView=[self.storyboard instantiateViewControllerWithIdentifier:@"mainScrollView" ];
            [UIView beginAnimations:nil context:nil];
            [UIView setAnimationDuration:0.5];
            [UIView setAnimationCurve:UIViewAnimationCurveEaseOut];
            [loadingView setAlpha:0.5f];
            [UIView commitAnimations];
            [spinner startAnimating];
            [self appdelegate].isRestaurantsScreenLoaded=NO;
            [self appdelegate].isHorizontalScreenLoaded=NO;
            [self appdelegate].isFindNearby = YES;
            [self appdelegate].isLocationForFindNearby = YES;
            [self animateViewChange];
            LocationManager*man=[LocationManager getInstance];
            [man getLocation];
//            [[self navigationController] pushViewController: mainScrollView animated:NO];
        }
        else
        {
            UIAlertView*alert=[[UIAlertView alloc]initWithTitle:@""
                                                        message:NSLocalizedString(@"TurnOnLocation", nil)
                                                       delegate:self
                                              cancelButtonTitle:NSLocalizedString(@"OkButton", nil)
                                              otherButtonTitles:nil  , nil];
            [alert show];
        }
    }
    else
    {
        UIAlertView*alert=[[UIAlertView alloc]initWithTitle:@""
                                                    message:NSLocalizedString(@"NoNetwork", nil)
                                                   delegate:self
                                          cancelButtonTitle:NSLocalizedString(@"OkButton", nil)
                                          otherButtonTitles:nil  , nil];
        [alert show];
    }
    }
    
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    if (!isInfoShowed) {
         return [connManager.districts count]+2;
    }
    else
    {
        return 1;
    }
   
}


- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *simpleTableIdentifier = @"Districts";
    UIFont* font= [UIFont fontWithName:@"Futura" size:14];
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:simpleTableIdentifier];
    
    if (cell == nil) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:simpleTableIdentifier];
    }
    if (!isInfoShowed) {
        if (indexPath.row<[connManager.districts count]+1) {
            [cell.textLabel setText:[items objectAtIndex:indexPath.row]];
        }
        else
        {
            [cell.textLabel setText:NSLocalizedString(@"about", nil)];
        }
    }
    else
    {
        cell.textLabel.lineBreakMode = UILineBreakModeWordWrap;
        cell.textLabel.numberOfLines = 0;
       [cell.textLabel setText:NSLocalizedString(@"aboutText", nil)
       ];
    }
   
    cell.selectionStyle = UITableViewCellSelectionStyleGray;
    
    [cell.textLabel setFont:font];
    [cell.textLabel setTextColor:[UIColor colorWithWhite:0.3 alpha:1.f]];
    
    return cell;
}

- (void) tableView: (UITableView *) tableView didSelectRowAtIndexPath: (NSIndexPath *) indexPath {
    if (isInfoShowed) {
       [menu deselectRowAtIndexPath:[menu indexPathForSelectedRow] animated:YES];
    }
    else
    {
    [menu deselectRowAtIndexPath:[menu indexPathForSelectedRow] animated:YES];
    if(indexPath.row !=0){
          if (indexPath.row<[connManager.districts count]+1) {
        [self loadDistrictById:[[connManager.districts objectAtIndex:indexPath.row-1] districtId]];
          }
        else
        {
            [back setAlpha:1.0f];
            isInfoShowed=YES;
            [menu reloadData];
        }
    }
    else{
        NSLog(@"find nearby");
        [self goToFindNearby];
    }
    }
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
    if (!isInfoShowed) {
        return 44.0;
    }
    else 
    return self.view.frame.size.height-100;
}
-(void)animateViewChange{
    CATransition* transition = [CATransition animation];
    transition.duration = 0.4;
    transition.type = kCATransitionFade;
    transition.subtype = kCATransitionFromTop;
    [self.navigationController.view.layer
     addAnimation:transition forKey:kCATransition];
}


- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation{

    return NO;
}

-(BOOL)shouldAutorotate{
    
    return NO;
   
}

- (NSUInteger)supportedInterfaceOrientations{
    return UIInterfaceOrientationMaskPortrait;
}

- (UIInterfaceOrientation)preferredInterfaceOrientationForPresentation {
    return UIInterfaceOrientationPortrait;
}

- (void)willRotateToInterfaceOrientation:(UIInterfaceOrientation)toInterfaceOrientation duration:(NSTimeInterval)duration
{
//    [UIView setAnimationsEnabled:NO];
//    if(toInterfaceOrientation == UIInterfaceOrientationLandscapeRight
//       || toInterfaceOrientation == UIInterfaceOrientationLandscapeLeft){
//         [scrollView setPagingEnabled:NO];
//        [topBar setImage:[UIImage imageNamed:@"menu_horizontal.png"]];
//        for(int i=0; i<[scrollView subviews].count; i++){
//            UIView *tmp=[[scrollView subviews]objectAtIndex:i];
//            CGAffineTransform transform =CGAffineTransformScale(scrollView.transform, 0.6, 0.6);
//            if(IS_WIDESCREEN){
//                tmp.transform = CGAffineTransformTranslate(transform, 0, -(tmp.center.y * 0.7));
//            }
//            else{
//                tmp.transform = CGAffineTransformTranslate(transform, 0, -(tmp.center.y / 2));
//            }
//        }
//        scrollView.contentSize = CGSizeMake(scrollView.contentSize.width, scrollView.frame.size.height*0.5);
//        
//    }
//    else{
//         [scrollView setPagingEnabled:YES];
//        [topBar setImage:[UIImage imageNamed:@"menu_bg.png"]];
//        for(int i=0; i<[scrollView subviews].count; i++){
//            UIView *tmp=[[scrollView subviews]objectAtIndex:i];
//            CGAffineTransform transform =CGAffineTransformScale(scrollView.transform, 1, 1);
//            tmp.transform = CGAffineTransformTranslate(transform, 0, 0);
//        }
//        scrollView.contentSize = CGSizeMake(scrollView.contentSize.width, scrollView.frame.size.height);
//    }
//    [self animateViewChange];
}


- (void)didRotateFromInterfaceOrientation:(UIInterfaceOrientation)fromInterfaceOrientation
{
//    [UIView setAnimationsEnabled:YES];
//     [[UIDevice currentDevice] setOrientation:UIInterfaceOrientationPortrait];
    
}

- (void)viewDidUnload {
    [self setLoadingView:nil];
    [self setBack:nil];
    [super viewDidUnload];
}
- (IBAction)goBack:(id)sender {
    [back setAlpha:0.0f];
    isInfoShowed=NO;
    [menu reloadData];
}
@end






