//
//  InfoViewController.h
//  MenuMenu
//
//  Created by Pawel Ferens on 3/28/13.
//  Copyright (c) 2013 Pawel Ferens. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "Restaurant.h"  
#import "LocationManager.h"
#import <FacebookSDK/FacebookSDK.h>
#import <Twitter/Twitter.h>
#import <Accounts/Accounts.h>
#import <MessageUI/MessageUI.h>
#import "MapViewController.h"

@interface InfoViewController : UIViewController<UIScrollViewDelegate,MFMailComposeViewControllerDelegate,CLLocationManagerDelegate,MFMessageComposeViewControllerDelegate,UINavigationControllerDelegate,UIActionSheetDelegate,FBLoginViewDelegate>
- (IBAction)goBack:(id)sender;
@property NSURLConnection * connection;
@property (nonatomic,retain) NSMutableData * receivedData;
@property (strong, nonatomic) IBOutlet UIImageView *topBar;
@property (strong, nonatomic) IBOutlet UIImageView *bottomBar;
@property (strong, nonatomic) IBOutlet UIScrollView *scrollView;
@property(nonatomic,retain)   NSMutableArray* restaurants;
@property int index;
@property (strong, nonatomic) IBOutlet UILabel *distanceLabel;
@property (strong, nonatomic) IBOutlet UILabel *restNameLabel;
@property (strong, nonatomic) IBOutlet UILabel *restAddressLabel;
@property (strong, nonatomic) IBOutlet UIImageView *timeIcon;
@property (strong, nonatomic) IBOutlet UIImageView *locationIcon;
@property (strong, nonatomic) IBOutlet UIImageView *line;
@property(nonatomic,retain)LocationManager* man;
@property(nonatomic,retain)MapViewController* mapController;
@property(nonatomic,retain)UIImageView* imageToZom;
@property bool isInfoShowed;
@property (strong, nonatomic) IBOutlet UIButton *shareButton;
@property (strong, nonatomic) IBOutlet UIButton *mapButton;
@property (strong, nonatomic) IBOutlet UIButton *callButton;
@property NSOperationQueue *myQueue;
@property UIImage * imageToReplace;
@property  NSInvocationOperation *operation;
@property UIActivityIndicatorView*spinner;
- (IBAction)send:(id)sender;
- (IBAction)call:(id)sender;
- (IBAction)goToMap:(id)sender;
@end
