//
//  InfoViewController.m
//  MenuMenu
//
//  Created by Pawel Ferens on 3/28/13.
//  Copyright (c) 2013 Pawel Ferens. All rights reserved.
//

#import "InfoViewController.h"

@interface InfoViewController ()
@property bool isZoomed;
@end

@implementation InfoViewController
@synthesize restaurants;
@synthesize timeIcon;
@synthesize topBar;
@synthesize scrollView;
@synthesize restNameLabel;
@synthesize restAddressLabel;
@synthesize index;
@synthesize locationIcon;
@synthesize line;
@synthesize distanceLabel;
@synthesize bottomBar;
@synthesize man;
@synthesize imageToZom;
@synthesize isInfoShowed;
@synthesize shareButton;
@synthesize mapButton;
@synthesize callButton;
@synthesize mapController;
@synthesize isZoomed;
@synthesize myQueue;
@synthesize imageToReplace;
@synthesize operation;
@synthesize receivedData;
@synthesize connection;
@synthesize spinner;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}
-(void)viewWillAppear:(BOOL)animated
{
    
     [self appdelegate].rotateToLandScape=NO;
    isZoomed=NO;
}
-(void)messageComposeViewController:(MFMessageComposeViewController *)controller didFinishWithResult:(MessageComposeResult)result
{
     [self dismissModalViewControllerAnimated:NO];
}
- (void)viewDidLoad
{
    [super viewDidLoad];
    
    
    myQueue = [[NSOperationQueue alloc] init];
    myQueue.name = @"Download Queue";
    myQueue.MaxConcurrentOperationCount = 1;

    
    
    [topBar setAlpha:1.0f];
    [bottomBar setAlpha:1.0f];
    [line setAlpha:1.0f];
    [distanceLabel setAlpha:1.0f];
    [restAddressLabel setAlpha:1.0f];
    [timeIcon setAlpha:1.0f];
    [locationIcon setAlpha:1.0f];
    [shareButton setAlpha:1.0f];
    [mapButton setAlpha:1.0f];
    [callButton setAlpha:1.0f];
    isInfoShowed=YES;
    
    self.scrollView.minimumZoomScale=scrollView.frame.size.height / scrollView.frame.size.height;
    self.scrollView.maximumZoomScale=5.0;
    self.scrollView.delegate=self;
    
    
    UITapGestureRecognizer *doubleTap = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(handleDoubleTapFrom:)];
    
    [doubleTap setNumberOfTapsRequired:2];
    
    [self.imageToZom addGestureRecognizer:doubleTap];
     [self.scrollView addGestureRecognizer:doubleTap];
    
    
    UITapGestureRecognizer *singleTap = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(handleTapFrom:)];
    singleTap.numberOfTapsRequired = 1;
     [self.imageToZom addGestureRecognizer:singleTap];
      [self.scrollView addGestureRecognizer:singleTap];
    
    [singleTap requireGestureRecognizerToFail:doubleTap];
	
}


- (void)handleDoubleTapFrom:(id)sender {
    
    [self zoomToPoint:CGPointMake(imageToZom.frame.size.width/2, imageToZom.frame.size.height/2) withScale:2 animated:YES];
    
}

- (void)handleTapFrom:(id)sender {
    [UIView beginAnimations:nil context:nil];
    [UIView setAnimationDuration:0.3];
   
    [UIView setAnimationCurve:UIViewAnimationCurveEaseOut];

    if (isInfoShowed) {
        [topBar setAlpha:0.0f];
        [bottomBar setAlpha:0.0f];
        [line setAlpha:0.0f];
        [distanceLabel setAlpha:0.0f];
        [restAddressLabel setAlpha:0.0f];
        [timeIcon setAlpha:0.0f];
        [locationIcon setAlpha:0.0f];
        [shareButton setAlpha:0.0f];
        [mapButton setAlpha:0.0f];
        [callButton setAlpha:0.0f];
        isInfoShowed=NO;
    }
    else
    {
        [topBar setAlpha:1.0f];
        [bottomBar setAlpha:1.0f];
        [line setAlpha:1.0f];
        [distanceLabel setAlpha:1.0f];
        [restAddressLabel setAlpha:1.0f];
        [timeIcon setAlpha:1.0f];
        [locationIcon setAlpha:1.0f];
        [shareButton setAlpha:1.0f];
        [mapButton setAlpha:1.0f];
        [callButton setAlpha:1.0f];

        isInfoShowed=YES;
    }
    [UIView commitAnimations];
    NSLog(@"poszlo");
    
}
- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (IBAction)goBack:(id)sender {
    [connection cancel];
    [spinner stopAnimating];
    [self appdelegate].shouldReloadImage=NO;
    [self appdelegate].rotateToLandScape=NO;
    [self animateViewChange];
    [self.navigationController popViewControllerAnimated:NO];
}
- (void)viewDidUnload {
    [self setTopBar:nil];
    [self setBottomBar:nil];
    [self setScrollView:nil];
    [self setDistanceLabel:nil];
    [self setRestNameLabel:nil];
    [self setRestAddressLabel:nil];
    [self setTimeIcon:nil];
    [self setLocationIcon:nil];
    [self setLine:nil];
    [self setShareButton:nil];
    [self setMapButton:nil];
    [self setCallButton:nil];
    [self setCallButton:nil];
    [self setMapButton:nil];
    [self setShareButton:nil];
    [super viewDidUnload];
}

-(void)viewDidAppear:(BOOL)animated
{
    [shareButton setTitle:NSLocalizedString(@"shareButton", nil) forState:UIControlStateNormal];
    
    [mapButton setTitle:NSLocalizedString(@"mapButton", nil) forState:UIControlStateNormal];
    
    [callButton setTitle:NSLocalizedString(@"callButton", nil) forState:UIControlStateNormal];
    
    [topBar setAlpha:1.0f];
    [bottomBar setAlpha:1.0f];
    [line setAlpha:1.0f];
    [distanceLabel setAlpha:1.0f];
    [restAddressLabel setAlpha:1.0f];
    [timeIcon setAlpha:1.0f];
    [locationIcon setAlpha:1.0f];
    [shareButton setAlpha:1.0f];
    [mapButton setAlpha:1.0f];
    [callButton setAlpha:1.0f];
    isInfoShowed=YES;
    
    [self loadImage];
    int position;
    
    if (index>2000) {
            position=2000;
        }
    else if(index>=1000&&index<2000)
        {
            position=1000;
        }
    else
        {
            position=0;
        }
    
    Restaurant *temp=[restaurants objectAtIndex:(index-position)];
    [self appdelegate].currentIndex = (index-position);
    
   
        restNameLabel.text=temp.name;
        restAddressLabel.text=temp.address;
        
        man=[LocationManager getInstance];
        float a=[temp.lat floatValue];
        float b=[temp.lng floatValue];
        
        if(man.la!=0 && man.lo!=0){
            
            float dist = [man calculateDistanceWithLatA:man.la
                                                 andLoA:man.lo
                                                andLatB:a
                                                 andLoB:b];
            if(dist >= 1000){
                [distanceLabel setText: [NSString stringWithFormat: @"%0.2f km", dist/1000]];
                if([self appdelegate].isFindNearby)
                    distanceLabel.text = [NSString stringWithFormat: @"%@ %.2f km",
                                      NSLocalizedString(@"Distance", nil),
                                      temp.distance/1000];
            }
            else{
                [distanceLabel setText: [NSString stringWithFormat: @"%0.f m", dist]];
                if([self appdelegate].isFindNearby)
                    distanceLabel.text = [NSString stringWithFormat: @"%@ %.f m",
                                      NSLocalizedString(@"Distance", nil),
                                      temp.distance];
            }
        }
        else{
            [distanceLabel setText: @""];
        }

   
    [UIView beginAnimations:nil context:nil];
    [UIView setAnimationDuration:0.5];
    [UIView setAnimationDelay:1.0];
    [UIView setAnimationCurve:UIViewAnimationCurveEaseOut];
    [topBar setAlpha:0.0];
    [bottomBar setAlpha:0.0];
    [distanceLabel setAlpha:0.0];
    [line setAlpha:0.0];
    [locationIcon setAlpha:0.0];
    [restAddressLabel setAlpha:0.0];
    [timeIcon setAlpha:0.0];
    [shareButton setAlpha:0.0f];
    [mapButton setAlpha:0.0f];
    [callButton setAlpha:0.0f];
    
    isInfoShowed=NO;
    
    [UIView commitAnimations];
    
}

- (void)zoomToPoint:(CGPoint)zoomPoint withScale: (CGFloat)scale animated: (BOOL)animated
{
    //Normalize current content size back to content scale of 1.0f
    CGSize contentSize;
    
    contentSize.width = (scrollView.contentSize.width / scrollView.zoomScale);
    contentSize.height = (scrollView.contentSize.height / scrollView.zoomScale);
    
    //translate the zoom point to relative to the content rect
    zoomPoint.x = (zoomPoint.x / scrollView.bounds.size.width) * contentSize.width;
    zoomPoint.y = (zoomPoint.y / scrollView.bounds.size.height) * contentSize.height;
    
    //derive the size of the region to zoom to
    CGSize zoomSize;
    zoomSize.width = scrollView.bounds.size.width / scale;
    zoomSize.height = scrollView.bounds.size.height / scale;
    
    //offset the zoom rect so the actual zoom point is in the middle of the rectangle
    CGRect zoomRect;
    zoomRect.origin.x = zoomPoint.x - zoomSize.width / 2.0f;
    zoomRect.origin.y = zoomPoint.y - zoomSize.height / 2.0f;
    zoomRect.size.width = zoomSize.width;
    zoomRect.size.height = zoomSize.height;
    
    //apply the resize
    if (isZoomed) {
        [scrollView zoomToRect: imageToZom.frame animated: animated];
        isZoomed=NO;
    }
    else{
    [scrollView zoomToRect: zoomRect animated: animated];
        isZoomed=YES;
    }
}
- (AppDelegate *) appdelegate {
    return (AppDelegate *)[[UIApplication sharedApplication] delegate];
}

- (UIView *)viewForZoomingInScrollView:(UIScrollView *)scrollView{
//    isZoomed=YES;
    return self.imageToZom;
}

-(void)loadImage
{
   
    [UIView beginAnimations:nil context:nil];
    [UIView setAnimationDuration:0.5];                                      //animations
    [UIView setAnimationDelay:0.0];
    [UIView setAnimationCurve:UIViewAnimationCurveEaseOut];
    
    
    
    [imageToZom removeFromSuperview];
    int position;
    if (index>2000) {
        position=2000;
    }
    else if(index>=1000&&index<2000)
    {
        position=1000;
    }
    else
    {
        position=0;
    }
    
    
    
    for(UIView *subview in [scrollView subviews]) {
        [subview removeFromSuperview];
    }
    spinner=[[UIActivityIndicatorView alloc]initWithActivityIndicatorStyle:UIActivityIndicatorViewStyleWhite];
    
    [spinner setFrame:CGRectMake(self.view.frame.size.width/2-15, self.view.frame.size.height/2-15, 30, 30)];
    
    imageToZom=[[UIImageView alloc]initWithImage:[[restaurants objectAtIndex:(index-position)]downloadedMenuImage]];
    
    [imageToZom setFrame:CGRectMake(0, 0, scrollView.frame.size.width, imageToZom.frame.size.height*self.view.frame.size.width/imageToZom.frame.size.width)];
    [imageToZom setContentMode: UIViewContentModeScaleAspectFill];
    
    [scrollView setContentSize:CGSizeMake(scrollView.frame.size.width, imageToZom.frame.size.height*self.view.frame.size.width/imageToZom.frame.size.width)];
    
    [self.view addSubview:spinner];
    [scrollView addSubview:imageToZom];
    //[self zoomToPoint:CGPointMake(imageToZom.frame.size.width/2, imageToZom.frame.size.height/2) withScale:1.5 animated:YES];
    [spinner startAnimating];
    
    NSString*blobEnding2=[[restaurants objectAtIndex:(index-position)] menuImageScaleSize];
    NSURL *url1 = [NSURL URLWithString:blobEnding2];
    

    
    NSURLRequest *request = [NSURLRequest requestWithURL:url1];
    connection= [[NSURLConnection alloc] initWithRequest:request delegate:self] ;
   
//    [operation cancel];

 //////////////////////
    
//    myQueue = [[NSOperationQueue alloc] init];
//    myQueue.name = @"Download Queue";
//    myQueue.MaxConcurrentOperationCount = 1;
//    
//    [myQueue addOperationWithBlock: ^ {
//        
//        
//        NSString*blobEnding2=[[restaurants objectAtIndex:(index-position)] menuImageScaleSize];
//        NSURL *url1 = [NSURL URLWithString:blobEnding2];
//        NSData *data1 = [NSData dataWithContentsOfURL:url1];
//        
//        UIImage* temp=[[UIImage alloc]initWithData:data1];;
//        // Get hold of main queue (main thread)
//        [[NSOperationQueue mainQueue] addOperationWithBlock: ^ {
//            [spinner stopAnimating];
//            if(temp!=nil)
//            {
//                [UIView beginAnimations:nil context:nil];
//                [UIView setAnimationDuration:0.5];
//                [UIView setAnimationCurve:UIViewAnimationCurveEaseOut];
//                
//                [imageToZom setImage:temp];
//               
//                
//                [UIView commitAnimations];
//                
//            }
//            [UIView commitAnimations];
//            [imageToZom setContentMode: UIViewContentModeScaleAspectFill];
//
//        }];
//        
//    }];
    
   ////////////////////////////
    
//    dispatch_async( dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
//       
//        NSString*blobEnding2=[[restaurants objectAtIndex:(index-position)] menuImageScaleSize];
//        NSURL *url1 = [NSURL URLWithString:blobEnding2];
//        NSData *data1 = [NSData dataWithContentsOfURL:url1];
//        
//        UIImage* temp=[[UIImage alloc]initWithData:data1];;
//        
//        dispatch_async( dispatch_get_main_queue(), ^{
//            [spinner stopAnimating];
//            if(temp!=nil)
//            {
//                [UIView beginAnimations:nil context:nil];
//                [UIView setAnimationDuration:0.5];
//                [UIView setAnimationCurve:UIViewAnimationCurveEaseOut];
//                     [imageToZom setImage:temp];
////                
//               
//             
//                [UIView commitAnimations];
//    
//            }
//            [UIView commitAnimations];
//           [imageToZom setContentMode: UIViewContentModeScaleAspectFill];
//
//        });
//    });
    

    [scrollView setAlpha:1.0f];
    

}


- (void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response
{
    receivedData=[[NSMutableData alloc]init];
}
- (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data
{
    [receivedData appendData:data];
}
- (void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error
{
    [spinner stopAnimating];
    
}
- (void)connectionDidFinishLoading:(NSURLConnection *)connection
{
    [spinner stopAnimating];
    UIImage* temp=[[UIImage alloc]initWithData:receivedData];;
    [imageToZom setImage:temp];
    [UIView commitAnimations];
    [imageToZom setContentMode: UIViewContentModeScaleAspectFill];
}


-(BOOL)isPad
{
#ifdef UI_USER_INTERFACE_IDIOM
    return UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad;
#endif
    return NO;
}
- (IBAction)send:(id)sender {
    
    
    if ([self isPad]) {
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:NSLocalizedString(@"Not supported", nil)
                                                        message:NSLocalizedString(@"Sharing is not avaible on iPad", nil)
                                                       delegate:nil
                                              cancelButtonTitle:NSLocalizedString(@"OkButton", nil)
                                              otherButtonTitles:nil];;
        
        [alert show];
    }
    else
    {
    NSString *actionSheetTitle = @""; //Action Sheet Title
    NSString *other1 = @"";
    NSString *other2 = @"";
    NSString *other3 = @"";
    NSString *other4 = @"";
    NSString *cancelTitle = @"Cancel";
    UIActionSheet *actionSheet = [[UIActionSheet alloc]
                                  initWithTitle:actionSheetTitle
                                  delegate:self
                                  cancelButtonTitle:cancelTitle
                                  destructiveButtonTitle:nil
                                  otherButtonTitles:other1, other2, other3,other4, nil];
    actionSheet.actionSheetStyle=UIActionSheetStyleBlackOpaque;
    [actionSheet showInView:self.view];
    actionSheet.alpha=0.9;// setAlpha:0.8];
    
    
    UIButton*temp=[[actionSheet subviews]objectAtIndex:1];
    [temp setBackgroundImage:[UIImage imageNamed:@"email.png"] forState:UIControlStateNormal];
    [temp setBackgroundImage:[UIImage imageNamed:@"email2.png"] forState:UIControlStateHighlighted];
    [temp setBounds:CGRectMake(0, 0, 65, 65)];
    [temp setBackgroundColor:[UIColor blackColor]];
    [temp setCenter:CGPointMake(60, 66)];
    [temp setBackgroundColor:[UIColor clearColor]];
    UIFont* font=[UIFont fontWithName:@"Helvetica-Bold" size:12.0];
    UILabel*title=[[UILabel alloc]initWithFrame:CGRectMake(0, 68, 65, 12)];
    [title setTextAlignment:NSTextAlignmentCenter];
    title.font=font;
    title.text=@"Mail";
    title.backgroundColor=[UIColor clearColor];
    title.textColor=[UIColor whiteColor];
    [temp addSubview:title];
    
    
    UIButton*temp2=[[actionSheet subviews]objectAtIndex:2];
    [temp2 setBackgroundImage:[UIImage imageNamed:@"message.png"] forState:UIControlStateNormal];
    [temp2 setBackgroundImage:[UIImage imageNamed:@"message2.png"] forState:UIControlStateHighlighted];
    [temp2 setBounds:CGRectMake(0, 0, 60, 60)];
    [temp2 setBackgroundColor:[UIColor blackColor]];
    [temp2 setCenter:CGPointMake(self.view.frame.size.width/2, 65)];
    [temp2 setBackgroundColor:[UIColor clearColor]];
    UILabel*title2=[[UILabel alloc]initWithFrame:CGRectMake(0, 65, 60, 12)];
    [title2 setTextAlignment:NSTextAlignmentCenter];
    title2.font=font;
    title2.text=@"Message";
    title2.backgroundColor=[UIColor clearColor];
    title2.textColor=[UIColor whiteColor];
    [temp2 addSubview:title2];
    
    UIButton*temp3=[[actionSheet subviews]objectAtIndex:3];
    [temp3 setBackgroundImage:[UIImage imageNamed:@"twitter.png"] forState:UIControlStateNormal];
    [temp3 setBackgroundImage:[UIImage imageNamed:@"twitter2.png"] forState:UIControlStateHighlighted];
    [temp3 setBounds:CGRectMake(0, 0, 60, 60)];
    [temp3 setBackgroundColor:[UIColor blackColor]];
    [temp3 setCenter:CGPointMake(260, 65)];
    [temp3 setBackgroundColor:[UIColor clearColor]];
    UILabel*title3=[[UILabel alloc]initWithFrame:CGRectMake(0, 65, 60, 12)];
    [title3 setTextAlignment:NSTextAlignmentCenter];
    title3.font=font;
    title3.text=@"Twitter";
    title3.backgroundColor=[UIColor clearColor];
    title3.textColor=[UIColor whiteColor];
    [temp3 addSubview:title3];
    
    UIButton*temp4=[[actionSheet subviews]objectAtIndex:4];
    [temp4 setBackgroundImage:[UIImage imageNamed:@"facebook.png"] forState:UIControlStateNormal];
    [temp4 setBackgroundImage:[UIImage imageNamed:@"facebook2.png"] forState:UIControlStateHighlighted];
    [temp4 setBounds:CGRectMake(0, 0, 60, 60)];
    [temp4 setBackgroundColor:[UIColor blackColor]];
    [temp4 setCenter:CGPointMake(60, 180)];
    [temp4 setBackgroundColor:[UIColor clearColor]];
    UILabel*title4=[[UILabel alloc]initWithFrame:CGRectMake(0, 65, 60, 12)];
    [title4 setTextAlignment:NSTextAlignmentCenter];
    title4.font=font;
    title4.text=@"Facebook";
    title4.backgroundColor=[UIColor clearColor];
    title4.textColor=[UIColor whiteColor];
    [temp4 addSubview:title4];
    
    }
    
    
}

- (IBAction)call:(id)sender {
    
    int position;
    if (index>2000) {
        position=2000;
    }
    else if(index>=1000&&index<2000)
    {
        position=1000;
    }
    else
    {
        position=0;
    }
    
    UIDevice *device = [UIDevice currentDevice];
    
    if ([[device model] isEqualToString:@"iPhone"] ) {
        
        if (![[[restaurants objectAtIndex:index-position] phoneRestaurant]isEqualToString:@""]) {
            
            NSString *str = [[restaurants objectAtIndex:index-position] phoneRestaurant];
            
            
            
            str = [str stringByReplacingOccurrencesOfString:@" "
                   
                                                 withString:@""];
            
            
            
            str = [str stringByReplacingOccurrencesOfString:@"-"
                   
                                                 withString:@""];
            
            
            
            str = [str stringByReplacingOccurrencesOfString:@"."
                   
                                                 withString:@""];
            
            
            
            str = [str stringByReplacingOccurrencesOfString:@":"
                   
                                                 withString:@""];
            
            
            
            
            
            NSString *phoneNumber = [@"telprompt://" stringByAppendingString:str];
            
            [[UIApplication sharedApplication] openURL:[NSURL URLWithString:phoneNumber]];
            
            
            
            
            
        }
        
        else
            
        {
            
            UIAlertView *Notpermitted=[[UIAlertView alloc] initWithTitle:@""
                                       
                                                                 message: NSLocalizedString(@"NoNumber", nil)
                                       
                                                                delegate:nil
                                       
                                                       cancelButtonTitle:NSLocalizedString(@"OkButton", nil)
                                       
                                                       otherButtonTitles:nil];
            
            [Notpermitted show];
            
        }
        
        
        
    } else {
        
        UIAlertView *Notpermitted=[[UIAlertView alloc] initWithTitle:@""
                                   
                                                             message:NSLocalizedString(@"NotSupported Feature", nil)
                                   
                                                            delegate:nil
                                   
                                                   cancelButtonTitle:NSLocalizedString(@"OkButton", nil)
                                   
                                                   otherButtonTitles:nil];
        
        [Notpermitted show];
        
        
        
    }
    
}

-(void)animateViewChange{
    CATransition* transition = [CATransition animation];
    transition.duration = 0.4;
    transition.type = kCATransitionFade;
    transition.subtype = kCATransitionFromTop;
    [self.navigationController.view.layer
     addAnimation:transition forKey:kCATransition];
}
- (IBAction)goToMap:(id)sender {
    int position;
    if (index>2000) {
        position=2000;
    }
    else if(index>=1000&&index<2000)
    {
        position=1000;
    }
    else
    {
        position=0;
    }
    mapController=[self.storyboard instantiateViewControllerWithIdentifier:@"map" ];
    Restaurant* temp=[restaurants objectAtIndex:index-position];
    mapController.restaurant=temp;
    mapController.distance=self.distanceLabel.text;
    [self animateViewChange];
    [self.navigationController pushViewController:mapController animated:NO];
    
}


- (void)actionSheet:(UIActionSheet *)actionSheet clickedButtonAtIndex:(NSInteger)buttonIndex {
    if(buttonIndex==0)
    {
        if ([MFMailComposeViewController canSendMail])
        {
            int position;
            if (index>2000) {
                position=2000;
            }
            else if(index>=1000&&index<2000)
            {
                position=1000;
            }
            else
            {
                position=0;
            }

            
            Restaurant *temp=[restaurants objectAtIndex:index-position];
            NSString* someText = [NSString stringWithFormat:@"%@ %@", NSLocalizedString(@"MAILBODY", nil),temp.address];
            //        NSString* someText = [NSString stringWithFormat:@"%@ %@", @"Come to restaurant at",temp.address];
            
            MFMailComposeViewController *mailer = [[MFMailComposeViewController alloc] init];
            mailer.mailComposeDelegate = self;
            [mailer setSubject:NSLocalizedString(@"MailSubject", nil)];
            
            UIImage *myImage = temp.downloadedMainImage;
            NSData *imageData = UIImagePNGRepresentation(myImage);
            [mailer addAttachmentData:imageData mimeType:@"image/png" fileName:@"main"];
            
            UIImage *myImage2 = temp.downloadedMenuImage;
            NSData *imageData2 = UIImagePNGRepresentation(myImage2);
            [mailer addAttachmentData:imageData2 mimeType:@"image/png" fileName:@"menu"];
            
            
            NSString *emailBody = someText;
            [mailer setMessageBody:emailBody isHTML:NO];
            [self presentModalViewController:mailer animated:YES];
        }
        else
        {
            UIAlertView *alert = [[UIAlertView alloc] initWithTitle:NSLocalizedString(@"Failure", nil)
                                                            message:NSLocalizedString(@"MComposer NotSupported", nil)
                                                           delegate:nil
                                                  cancelButtonTitle:NSLocalizedString(@"OkButton", nil)
                                                  otherButtonTitles:nil];;
            
            [alert show];
            
        }
    }
    else if (buttonIndex==1)
    {
        MFMessageComposeViewController *controller = [[MFMessageComposeViewController alloc] init];
        if([MFMessageComposeViewController canSendText])
        {
            int position;
            if (index>2000) {
                position=2000;
            }
            else if(index>=1000&&index<2000)
            {
                position=1000;
            }
            else
            {
                position=0;
            }

            Restaurant* showedRestaurant=[restaurants objectAtIndex:index-position];
            NSString* someText = showedRestaurant.name;
            controller.body =someText;
            controller.recipients = [NSArray arrayWithObjects:@"", nil];
            controller.messageComposeDelegate = self;
            controller.delegate = self;
            [self presentModalViewController:controller animated:YES];
        }
    }
    else if (buttonIndex==2)
    {
        [self sendEasyTweet:nil];
    }
    else if (buttonIndex==3)
    {
        
        
        [self openSession];
    }
}

- (IBAction)sendEasyTweet:(id)sender {
    // Set up the built-in twitter composition view controller.
    TWTweetComposeViewController *tweetViewController = [[TWTweetComposeViewController alloc] init];
    int position;
    if (index>2000) {
        position=2000;
    }
    else if(index>=1000&&index<2000)
    {
        position=1000;
    }
    else
    {
        position=0;
    }

    Restaurant*t=[restaurants objectAtIndex:index-position];
    // Set the initial tweet text. See the framework for additional properties that can be set.
    NSString * content=[NSString stringWithFormat:@"Come here. It's a great restaurant! %@  at %@",t.name,t.address];
    [tweetViewController setInitialText:content];
    [tweetViewController addImage:t.downloadedMainImage];
    [tweetViewController addImage:t.downloadedMenuImage];
    // Create the completion handler block.
    [tweetViewController setCompletionHandler:^(TWTweetComposeViewControllerResult result) {
        NSString *output;
        
        switch (result) {
            case TWTweetComposeViewControllerResultCancelled:
                // The cancel button was tapped.
                output = @"Tweet cancelled.";
                break;
            case TWTweetComposeViewControllerResultDone:
                // The tweet was sent.
                output = @"Tweet done.";
                break;
            default:
                break;
        }
        
        // [self performSelectorOnMainThread:@selector(displayText:) withObject:output waitUntilDone:NO];
        
        // Dismiss the tweet composition view controller.
        [self dismissModalViewControllerAnimated:YES];
    }];
    
    // Present the tweet composition view controller modally.
    [self presentModalViewController:tweetViewController animated:YES];
}


- (void) performPublishAction:(void (^)(void)) action {
    NSLog(@"wywolano");
    // we defer request for permission to post to the moment of post, then we check for the permission
    if ([FBSession.activeSession.permissions indexOfObject:@"publish_actions"] == NSNotFound) {
        // if we don't already have the permission, then we request it now
        [FBSession.activeSession requestNewPublishPermissions:@[@"publish_actions"]
                                              defaultAudience:FBSessionDefaultAudienceFriends
                                            completionHandler:^(FBSession *session, NSError *error) {
                                                if (!error) {
                                                    action();
                                                }
                                                //For this example, ignore errors (such as if user cancels).
                                            }];
    } else {
        action();    }
    
}

- (IBAction)postPhotoClick:(UIButton *)sender {

    int position;
    if (index>2000) {
        position=2000;
    }
    else if(index>=1000&&index<2000)
    {
        position=1000;
    }
    else
    {
        position=0;
    }

    UIImage *img = [[restaurants objectAtIndex:index-position] downloadedMenuImage];
    
   
    [self performPublishAction:^{
        
        [FBRequestConnection startForUploadPhoto:img
                               completionHandler:^(FBRequestConnection *connection, id result, NSError *error) {
                                   
                                   [self postStatusUpdateClick:nil];
                               }];
        
    }];
    
}
//}

- (IBAction)postStatusUpdateClick:(UIButton *)sender {
    // Post a status update to the user's feed via the Graph API, and display an alert view
    // with the results or an error.
    
    // if it is available to us, we will post using the native dialog
    BOOL displayedNativeDialog = [FBNativeDialogs presentShareDialogModallyFrom:self
                                                                    initialText:nil
                                                                          image:nil
                                                                            url:nil
                                                                        handler:nil];
    if (!displayedNativeDialog) {
        int position;
        if (index>2000) {
            position=2000;
        }
        else if(index>=1000&&index<2000)
        {
            position=1000;
        }
        else
        {
            position=0;
        }

        Restaurant*t=[restaurants objectAtIndex:index-position];
        [self performPublishAction:^{
            // otherwise fall back on a request for permissions and a direct post
            NSString *message = [NSString stringWithFormat:@"Come to restaurant %@ at %@",t.name, t.address];
            
            [FBRequestConnection startForPostStatusUpdate:message
                                        completionHandler:^(FBRequestConnection *connection, id result, NSError *error) {
                                            
                                            UIAlertView*alert=[[UIAlertView alloc]initWithTitle:NSLocalizedString(@"Success", nil) message:NSLocalizedString(@"Post Uploaded", nil) delegate:nil cancelButtonTitle:@"Ok" otherButtonTitles:nil, nil];
                                            [alert show];
                                            
                                        }];
            
            
        }];
    }
}
- (void)sessionStateChanged:(FBSession *)session
                      state:(FBSessionState) state
                      error:(NSError *)error
{
    switch (state) {
        case FBSessionStateOpen: {
            NSLog(@"poszlo ok");
            [self postPhotoClick:nil];
            
        }
            break;
        case FBSessionStateClosed:
        case FBSessionStateClosedLoginFailed:
        {
            NSLog(@"poszlo zle");
        }
            
            [FBSession.activeSession closeAndClearTokenInformation];
            
            
            break;
        default:
            break;
    }
    
    if (error) {
        UIAlertView *alertView = [[UIAlertView alloc]
                                  initWithTitle:NSLocalizedString(@"Error", nil)
                                  message:error.localizedDescription
                                  delegate:nil
                                  cancelButtonTitle:NSLocalizedString(@"OkButton", nil)
                                  otherButtonTitles:nil];
        [alertView show];
    }
}
- (BOOL)application:(UIApplication *)application
            openURL:(NSURL *)url
  sourceApplication:(NSString *)sourceApplication
         annotation:(id)annotation
{
    return [FBSession.activeSession handleOpenURL:url];
}

- (void)openSession
{
    [FBSession openActiveSessionWithReadPermissions:nil
                                       allowLoginUI:YES
                                  completionHandler:
     ^(FBSession *session,
       FBSessionState state, NSError *error) {
         [self sessionStateChanged:session state:state error:error];
     }];
}
- (void)mailComposeController:(MFMailComposeViewController*)controller didFinishWithResult:(MFMailComposeResult)result error:(NSError*)error
{
    switch (result)
    {
        case MFMailComposeResultCancelled:
            NSLog(@"Mail cancelled: you cancelled the operation and no email message was queued.");
            break;
        case MFMailComposeResultSaved:
            NSLog(@"Mail saved: you saved the email message in the drafts folder.");
            break;
        case MFMailComposeResultSent:
            NSLog(@"Mail send: the email message is queued in the outbox. It is ready to send.");
            break;
        case MFMailComposeResultFailed:
            NSLog(@"Mail failed: the email message was not saved or queued, possibly due to an error.");
            break;
        default:
            NSLog(@"Mail not sent.");
            break;
    }
    // Remove the mail view
    [self dismissModalViewControllerAnimated:YES];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation{
   
    return NO;
}

-(BOOL)shouldAutorotate{
    
    return NO;
  
}

- (NSUInteger)supportedInterfaceOrientations{
    return UIInterfaceOrientationMaskPortrait;
}

- (UIInterfaceOrientation)preferredInterfaceOrientationForPresentation {
    return UIInterfaceOrientationPortrait;
}

- (void)willRotateToInterfaceOrientation:(UIInterfaceOrientation)toInterfaceOrientation duration:(NSTimeInterval)duration
{
  
}


- (void)didRotateFromInterfaceOrientation:(UIInterfaceOrientation)fromInterfaceOrientation
{
    //    [UIView setAnimationsEnabled:YES];
    
}
@end
