//
//  LocationManager.m
//  MenuMenu
//
//  Created by Pawel Ferens on 3/1/13.
//  Copyright (c) 2013 Pawel Ferens. All rights reserved.
//

#import "LocationManager.h"

@implementation LocationManager
@synthesize locationManager;
@synthesize la;
@synthesize lo;
static LocationManager *instance =nil;

+(LocationManager *)getInstance
{
    @synchronized(self)
    {
        if(instance==nil){
            instance= [LocationManager new];
            
        }
    }
    return instance;
}
-(void)getLocation{
    if ([CLLocationManager locationServicesEnabled]) {
        locationManager=[[CLLocationManager alloc]init];
        locationManager.delegate=self;
        locationManager.purpose=NSLocalizedString(@"LocationRequired", nil);
        [locationManager startUpdatingLocation];
    }
    else{
        UIAlertView*alert=[[UIAlertView alloc]initWithTitle:@""
                                                    message:NSLocalizedString(@"TurnOnLocation", nil)
                                                   delegate:self
                                          cancelButtonTitle:NSLocalizedString(@"OkButton", nil)
                                          otherButtonTitles:nil];
        [alert show];
    }
    
    
}
-(void)locationManager:(CLLocationManager *)manager didUpdateToLocation:(CLLocation *)newLocation fromLocation:(CLLocation *)oldLocation
{
    NSLog(@"wsp: %f",newLocation.coordinate.latitude);
    la=newLocation.coordinate.latitude;
    
    NSLog(@"wsp2: %f",newLocation.coordinate.longitude);
    lo=newLocation.coordinate.longitude;
    [locationManager stopUpdatingLocation];
    

    
    
    if([self appdelegate].isLocationForFindNearby){
        
        
        NSString *notificationName = @"currentLocationSet";
        [[NSNotificationCenter defaultCenter] postNotificationName:notificationName object:nil ];
        [self appdelegate].isLocationForFindNearby = NO;
    }
    
}
-(double)calculateDistanceWithLatA:(float)latA
                          andLoA:(float)loA
                         andLatB:(float)latB
                          andLoB:(float)loB
{
    CLLocation *locA = [[CLLocation alloc] initWithLatitude:latA longitude:loA];
    
    CLLocation *locB = [[CLLocation alloc] initWithLatitude:latB longitude:loB];
    
    CLLocationDistance distance = [locA distanceFromLocation:locB];
    double a=distance;
    NSLog(@"%f",distance);
    return a;

}

- (void)locationManager: (CLLocationManager *)manager
       didFailWithError: (NSError *)error {
    
    NSString *errorString;
    [manager stopUpdatingLocation];
    NSLog(@"Error: %@",[error localizedDescription]);
    if([self appdelegate].isLocationForFindNearby){
        switch([error code]) {
            case kCLErrorDenied:
                //Access denied by user
                errorString = NSLocalizedString(@"DeniedByUser", nil);
                break;
            case kCLErrorLocationUnknown:
                //Probably temporary...
                errorString = NSLocalizedString(@"LocationUnavailable", nil);
                break;
            default:
                errorString = NSLocalizedString(@"UnknownError", nil);
                break;
        }

        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:NSLocalizedString(@"Error", nil)
                                                        message:errorString
                                                       delegate:self
                                              cancelButtonTitle:NSLocalizedString(@"OkButton", nil)
                                              otherButtonTitles:nil, nil];
        alert.tag=0;
        [alert show];
    }
}

- (void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex {
    if(alertView.tag == 0){
        NSLog(@"notify");
        NSString *notificationName = @"goBack";
        [[NSNotificationCenter defaultCenter] postNotificationName:notificationName object:nil ];
    }
}

- (AppDelegate *) appdelegate {
    return (AppDelegate *)[[UIApplication sharedApplication] delegate];
}
@end
