//
//  MainScrollViewController.h
//  MenuMenu
//
//  Created by Pawel Ferens on 2/26/13.
//  Copyright (c) 2013 Pawel Ferens. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "ConnectionManager.h"
#import "SingleScrollViewController.h"
#import "District.h"
#import "AppDelegate.h"
#import "RestaurantsHorizontalViewController.h"
#import <QuartzCore/QuartzCore.h>
#import "InfoViewController.h"
@interface MainScrollViewController : UIViewController <UIScrollViewDelegate>
{
    RestaurantsHorizontalViewController *restaurantsHorizontalView;
    
}
@property (strong, nonatomic) IBOutlet UIScrollView *scrollView;
@property (nonatomic,retain)NSMutableArray* restaurantList;
@property (strong, nonatomic) IBOutlet UIImageView *leftBar;
@property (strong, nonatomic) IBOutlet UIImageView *rightBar;
@property (strong, nonatomic) IBOutlet UIImageView *topBar;
@property (nonatomic,retain) ConnectionManager* connectionManager;
@property int screenWidth;
@property int screenHeigth;
@property(nonatomic,retain)NSMutableArray* thumbnails;
@property (strong, nonatomic) IBOutlet UIImageView *scrollViewBackground;

@property int leftColumnSize;
@property int rightColumnSize;
@property int posx;

@property(nonatomic,retain)NSMutableArray* orderOfDownloadedImages;

@property (weak, nonatomic) IBOutlet UIImageView *backButton;
@property (weak, nonatomic) IBOutlet UIButton *goBack;

@property (strong, nonatomic) IBOutlet UIImageView *loadingView;
@property(nonatomic, retain)NSString *districtId;
- (IBAction)goBack:(id)sender;
@property (strong, nonatomic) IBOutlet UILabel *cityLabel;
@property(nonatomic,retain)SingleScrollViewController*singleScrollViewController;
@property(nonatomic,retain)UIActivityIndicatorView* spinner;
@property(nonatomic, retain) LocationManager *locationManager;
@property(nonatomic, retain) NSMutableArray* headersImg;
@property(nonatomic, retain) NSMutableArray* menusImg;
@property (nonatomic,retain)InfoViewController* infoViewController;
@property int counter;
@property int counter2;
- (IBAction)switchOrientation:(id)sender;
@end
