//
//  MapViewController.m
//  MenuMenu
//
//  Created by Pawel Ferens on 3/1/13.
//  Copyright (c) 2013 Pawel Ferens. All rights reserved.
//

#import "MapViewController.h"

@interface MapViewController ()

@end

@implementation MapViewController
@synthesize mapController,restaurant,webView,distance,distanceLabel;
@synthesize topBar;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
    
}

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view.
    
    
}

-(void)viewWillAppear:(BOOL)animated{
    [self appdelegate].rotateToLandScape=YES;
}

-(void)viewDidAppear:(BOOL)animated
{
    distanceLabel.text=distance;
    CLLocationCoordinate2D location=CLLocationCoordinate2DMake([restaurant.lat doubleValue], [restaurant.lng doubleValue]);
    
    MKPointAnnotation *annotationPoint = [[MKPointAnnotation alloc]init];
    annotationPoint.coordinate = location;
    annotationPoint.title=restaurant.name;
    annotationPoint.subtitle = restaurant.address;
    [mapController addAnnotation:annotationPoint];
    
    MKCoordinateRegion viewRegion = MKCoordinateRegionMakeWithDistance(location, 0.5*1000, 0.5*1000);
    
    MKCoordinateRegion adjustedRegion = [mapController regionThatFits:viewRegion];
    
    [mapController setRegion:adjustedRegion animated:YES];
    
    LocationManager*conM=[LocationManager getInstance];
    NSString *urlAddress =[NSString stringWithFormat:@"https://maps.google.com/maps?saddr=%f,%f&daddr=%f,%f&dirflg=w&output=embed&z=zoom",conM.la,conM.lo,[restaurant.lat floatValue],[restaurant.lng floatValue]];
    
    ;
    NSURL *url = [NSURL URLWithString:urlAddress];
    NSURLRequest *requestObj = [NSURLRequest requestWithURL:url];
    [webView loadRequest:requestObj];
    
    
    
    
    
    
}
- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)viewDidUnload {
    [self setMapController:nil];
    [self setWebView:nil];
    [self setDistanceLabel:nil];
    [super viewDidUnload];
}
- (IBAction)goBack:(id)sender {
     [self appdelegate].rotateToLandScape=NO;
    
    CATransition* transition = [CATransition animation];
    transition.duration = 0.4;
    transition.type = kCATransitionFade;
    transition.subtype = kCATransitionFromTop;
    [self.navigationController.view.layer
     addAnimation:transition forKey:kCATransition];
    [self.navigationController popViewControllerAnimated:NO];
}

- (IBAction)showWay:(id)sender {
    [UIView beginAnimations:nil context:nil];
    [UIView setAnimationDuration:0.5];
    [UIView setAnimationCurve:UIViewAnimationCurveEaseOut];
    if (webView.alpha==0.0f) {
        
        [webView setAlpha:1.0f];
    }
    else{
        [webView setAlpha:0.0f];
    }
    [UIView commitAnimations];
}


-(void)animateViewChange{
    CATransition* transition = [CATransition animation];
    transition.duration = 0.4;
    transition.type = kCATransitionFade;
    transition.subtype = kCATransitionFromTop;
    [self.navigationController.view.layer
     addAnimation:transition forKey:kCATransition];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return NO;
}


- (void)willRotateToInterfaceOrientation:(UIInterfaceOrientation)toInterfaceOrientation duration:(NSTimeInterval)duration
{
    [UIView setAnimationsEnabled:NO]; // disable animations temporarily
    if(toInterfaceOrientation == UIInterfaceOrientationLandscapeLeft
       || toInterfaceOrientation == UIInterfaceOrientationLandscapeRight){
        [topBar setImage:[UIImage imageNamed:@"menu_horizontal.png"]];
    }
    else{
        [topBar setImage:[UIImage imageNamed:@"menu_bg.png"]];
    }
    
    [self animateViewChange];
}

- (void)didRotateFromInterfaceOrientation:(UIInterfaceOrientation)fromInterfaceOrientation
{
    
    [UIView setAnimationsEnabled:YES]; // rotation finished, re-enable them
}

- (AppDelegate *) appdelegate {
    return (AppDelegate *)[[UIApplication sharedApplication] delegate];
}
@end
