//
//  AppDelegate.m
//  MenuMenu
//
//  Created by Pawel Ferens on 2/26/13.
//  Copyright (c) 2013 Pawel Ferens. All rights reserved.
//

#import "AppDelegate.h"
#import "ViewController.h"


@implementation AppDelegate
@synthesize isRestaurantsScreenLoaded,isHorizontalScreenLoaded;
@synthesize isFindNearby;
@synthesize isLocationForFindNearby;
@synthesize rotateToLandScape;
@synthesize connection;
@synthesize currentIndex;
@synthesize shouldReloadImage;
- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    shouldReloadImage=YES;
    NSString *districtsCacheDir = [[NSSearchPathForDirectoriesInDomains(NSCachesDirectory, NSUserDomainMask, YES) lastObject] stringByAppendingPathComponent:@"districts"];
    if (![[NSFileManager defaultManager] fileExistsAtPath:districtsCacheDir])
        [[NSFileManager defaultManager] createDirectoryAtPath:districtsCacheDir withIntermediateDirectories:NO attributes:nil error:nil];
    
    
    NSString *logosCacheDir = [[NSSearchPathForDirectoriesInDomains(NSCachesDirectory, NSUserDomainMask, YES) lastObject] stringByAppendingPathComponent:@"logos"];
    if (![[NSFileManager defaultManager] fileExistsAtPath:logosCacheDir])
        [[NSFileManager defaultManager] createDirectoryAtPath:logosCacheDir withIntermediateDirectories:NO attributes:nil error:nil];
    
    
    isRestaurantsScreenLoaded=NO;
    isHorizontalScreenLoaded=NO;
    isFindNearby = NO;
    isLocationForFindNearby= NO;
    currentIndex=0;
    [UIView setAnimationsEnabled:YES];
    
    
    return YES;
}
-(void)cancelConnection
{
    [self.connection cancel];
}
- (void)applicationWillResignActive:(UIApplication *)application
{
    // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
    // Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
    // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later.
    // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
    // Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
    //[FBSession.activeSession handleDidBecomeActive];
    // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
}

- (void)applicationWillTerminate:(UIApplication *)application
{
    // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
}

- (NSUInteger) application:(UIApplication *)application supportedInterfaceOrientationsForWindow:(UIWindow *)window {
    
    return self.rotateToLandScape ?
    UIInterfaceOrientationMaskAllButUpsideDown :
    UIInterfaceOrientationMaskPortrait;
    
}

- (BOOL)application:(UIApplication *)application
            openURL:(NSURL *)url
  sourceApplication:(NSString *)sourceApplication
         annotation:(id)annotation
{
    // NSLog(@"dziala");
    return [FBSession.activeSession handleOpenURL:url];
}
@end
