//
//  RestaurantsHorizontalViewController.h
//  MenuMenu
//
//  Created by Sławek Derwisz on 27.02.2013.
//  Copyright (c) 2013 Pawel Ferens. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "ConnectionManager.h"
#import <MessageUI/MessageUI.h>
#import "LocationManager.h"
#import "MapViewController.h"
#import "AppDelegate.h"
#import <QuartzCore/QuartzCore.h>
#import <Twitter/Twitter.h>
#import <FacebookSDK/FacebookSDK.h>
@interface UIDevice (PrivateOrientation)
- (void) setOrientation:(UIInterfaceOrientation)orientation;
@end

@interface RestaurantsHorizontalViewController : UIViewController <MFMailComposeViewControllerDelegate,CLLocationManagerDelegate, UIScrollViewDelegate,FBLoginViewDelegate,UIActionSheetDelegate,MFMessageComposeViewControllerDelegate,UINavigationControllerDelegate>{
    
    IBOutlet UIScrollView *scrollView;
    IBOutlet UIImageView *topBar;
    IBOutlet UIView *locationBar;
    IBOutlet UIView *bottomBar;
    
    IBOutlet UILabel *name;
    IBOutlet UILabel *address;
    IBOutlet UILabel *distance;
    IBOutlet UILabel *hours;
    IBOutlet UILabel *districtLbl;
    
    IBOutlet UIButton *firstBtn;
    IBOutlet UIButton *phoneBtn;
    IBOutlet UIButton *mapBtn;
    IBOutlet UIButton *mailBtn;
    IBOutlet UIButton *lastBtn;
    
    ConnectionManager *connManager;
    int kNumberOfPages;
    CGRect pageFrame;
    CGRect bgFrame;
    
    NSArray *pages;
    bool isBarVisible;
    bool shouldReload;
    CGPoint scrollViewOffset;
    bool isPageChanged;
    NSArray* cachedRestaurants;
}
@property(nonatomic) int currentRestaurantIndex;
@property(nonatomic , retain)MapViewController* mapController;
@property (nonatomic, retain) NSString *currentDistrictName;
@property(nonatomic,retain)UIActivityIndicatorView* spinner;
@property(nonatomic, retain) LocationManager*locationManager;
@property(nonatomic,retain)NSMutableArray* restaurants;
@property(nonatomic) bool saveNewRestaurantJSON;
@property(nonatomic) bool changeDeviceOrientation;

-(IBAction) goBack;
- (IBAction)switchOrientation:(id)sender;
-(IBAction)goToFirst;
@end
