//
//  RestaurantsHorizontalViewController.m
//  MenuMenu
//
//  Created by Sławek Derwisz on 27.02.2013.
//  Copyright (c) 2013 Pawel Ferens. All rights reserved.
//

#import "RestaurantsHorizontalViewController.h"

@interface RestaurantsHorizontalViewController ()

@end

@implementation RestaurantsHorizontalViewController{
    NSMutableArray *isMenuTransformed;
}

@synthesize mapController;
@synthesize currentRestaurantIndex;
@synthesize spinner;
@synthesize locationManager;
@synthesize restaurants;
@synthesize changeDeviceOrientation;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}
-(void)messageComposeViewController:(MFMessageComposeViewController *)controller didFinishWithResult:(MessageComposeResult)result
{
    [self dismissModalViewControllerAnimated:YES];
}
-(void)viewWillAppear:(BOOL)animated{
//    [UIView beginAnimations:nil context:nil];
   
  
    isPageChanged = YES;
    [topBar setAlpha:0];
    NSLog(@"count: %d", connManager.restaurants.count > 0);
    if(changeDeviceOrientation)
        [[UIDevice currentDevice] setOrientation:[[UIApplication sharedApplication] statusBarOrientation]];
    
    
    districtLbl.text = [self currentDistrictName];
    [scrollView setContentOffset: CGPointMake(scrollView.frame.size.width*currentRestaurantIndex, 0)];
    scrollViewOffset = scrollView.contentOffset;
    if(restaurants.count > 0 && ![self appdelegate].isHorizontalScreenLoaded){
        [self prepareRestaurantsViews];
        NSLog(@"Current restaurant index: %d", currentRestaurantIndex);
    }
    cachedRestaurants=nil;
    NSString *cachesPath = [NSSearchPathForDirectoriesInDomains(NSCachesDirectory, NSUserDomainMask, YES) lastObject];
    NSString *cacheFile = [cachesPath
                           stringByAppendingPathComponent:[
                                                           [[restaurants lastObject] city]
                                                           stringByAppendingPathExtension:@"json"]];
    
    bool fileExists = [[NSFileManager defaultManager] fileExistsAtPath:cacheFile];
    NSError* error;
    if(fileExists){
        NSData *cachedJsonData = [[NSData alloc]initWithContentsOfFile: cacheFile];
        
        if(cachedJsonData != nil){
            cachedRestaurants = [NSJSONSerialization
                                  JSONObjectWithData: cachedJsonData
                                  options:kNilOptions
                                  error:&error];
        }
    }
}

-(void)viewDidAppear:(BOOL)animated{
//    [UIView setAnimationDuration:0.3];
    
    [mailBtn setTitle:NSLocalizedString(@"shareButton", nil) forState:UIControlStateNormal];
    
    [mapBtn setTitle:NSLocalizedString(@"mapButton", nil) forState:UIControlStateNormal];
    
    [phoneBtn setTitle:NSLocalizedString(@"callButton", nil) forState:UIControlStateNormal];
    
    [firstBtn setTitle:NSLocalizedString(@"firstBtn", nil) forState:UIControlStateNormal];
    
    [lastBtn setTitle:NSLocalizedString(@"lastBtn", nil) forState:UIControlStateNormal];
    
    
    NSLog(@"restaurants.count :%d", restaurants.count);
    self.changeDeviceOrientation=YES;
    if(restaurants.count > 0 && ![self appdelegate].isHorizontalScreenLoaded){
        NSLog(@"curr rest ind 2 : %d", currentRestaurantIndex);
        [self loadCurrentRestaurant: currentRestaurantIndex];
        [self loadOtherRestaurants: [NSNumber numberWithInt: currentRestaurantIndex]];
    }    [locationManager getLocation];
    
}

-(void) viewWillDisappear:(BOOL)animated{
    [UIView beginAnimations:nil context:nil];
    [UIView setAnimationDuration:0.5];
    [UIView setAnimationCurve:UIViewAnimationCurveEaseOut];
    
    bottomBar.alpha = 0;
    locationBar.alpha = 0;
    
    [UIView commitAnimations];
    [self animateViewChange];
    
  

}
- (void)viewDidLoad
{
    [super viewDidLoad];
 
    
  
    
    locationManager=[LocationManager getInstance];
    connManager = [ConnectionManager getInstance];
    pageFrame = CGRectMake(0,
                           0,
                           scrollView.frame.size.width,
                           scrollView.frame.size.height);
    bgFrame = pageFrame;
    kNumberOfPages = [connManager.restaurants count];
    scrollView.delegate = self;
    
    int screenHeigth=self.view.frame.size.height;
    int screenWidth=self.view.frame.size.width;
    spinner=[[UIActivityIndicatorView alloc]initWithActivityIndicatorStyle:UIActivityIndicatorViewStyleWhiteLarge];
    [spinner setFrame:CGRectMake(screenHeigth/2-15, screenWidth/2-15, 30, 30)];
    [spinner startAnimating];
    [self.view addSubview:spinner];
    [self appdelegate].isHorizontalScreenLoaded = NO;
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}

- (AppDelegate *) appdelegate {
    return (AppDelegate *)[[UIApplication sharedApplication] delegate];
}

-(IBAction) goBack{
    [self appdelegate].rotateToLandScape=NO;
    [self animateViewChange];
    [self.navigationController popToViewController:[self.navigationController.viewControllers objectAtIndex:2] animated:NO];
   // [self.navigationController popViewControllerAnimated:NO];
}

- (IBAction)switchOrientation:(id)sender{
    NSLog(@"switch");
    self.changeDeviceOrientation=YES;
    [self updateIndex];
    [self animateViewChange];
    [self.navigationController popViewControllerAnimated:NO];
}

-(IBAction)goToFirst{
    [scrollView setContentOffset:CGPointMake(0, 0) animated:YES];
}

-(IBAction)goToLast{
    [scrollView setContentOffset:CGPointMake(scrollView.contentSize.width-scrollView.frame.size.width, 0) animated:YES];
}

-(void)scrollViewDidEndScrollingAnimation:(UIScrollView *)scrollView{
    [self refreshBars];
}

-(void)scrollViewDidEndDecelerating:(UIScrollView *)scrollView{
    [self refreshBars];
    NSLog(@"refreshed");
}



-(void)scrollViewWillBeginDragging:(UIScrollView *)scroll
{
    if(isBarVisible){
        [UIView beginAnimations:nil context:nil];
        [UIView setAnimationDuration:0.3];
        [UIView setAnimationCurve:UIViewAnimationCurveEaseOut];
        
        bottomBar.alpha = 0;
        locationBar.alpha = 0;
        
        [UIView commitAnimations];
        isBarVisible = NO;
    }
  
}



-(void)refreshBars{
    [locationManager getLocation];
    if (scrollView.contentOffset.x >=0) {
         currentRestaurantIndex = floor(scrollView.contentOffset.x / pageFrame.size.width);
    }
   else
       currentRestaurantIndex=0;
    Restaurant *restaurant = [restaurants objectAtIndex:currentRestaurantIndex];
    [name setText:restaurant.name];
    [address setText:restaurant.address];
    
    float a=[restaurant.lat floatValue];
    float b=[restaurant.lng floatValue];
    
    if(locationManager.la!=0 && locationManager.lo!=0){
        restaurant.distance = [locationManager calculateDistanceWithLatA:locationManager.la
                                                         andLoA:locationManager.lo
                                                        andLatB:a
                                                         andLoB:b];
        if(restaurant.distance >= 1000){
            [distance setText: [NSString stringWithFormat: @"%0.2f km", restaurant.distance/1000]];
            if([self appdelegate].isFindNearby)
                districtLbl.text = [NSString stringWithFormat: @"%@ %.2f km",NSLocalizedString(@"Distance", nil),restaurant.distance/1000];
        }
        else{
            [distance setText: [NSString stringWithFormat: @"%0.f m", restaurant.distance]];
            if([self appdelegate].isFindNearby)
                districtLbl.text = [NSString stringWithFormat: @"%@ %.f m",NSLocalizedString(@"Distance", nil),restaurant.distance];
        }
    }
    else{
        [distance setText: @""];
    }
    
    NSCalendar *gregorian = [[NSCalendar alloc] initWithCalendarIdentifier:NSGregorianCalendar];
    NSDateComponents *comps = [gregorian components:NSWeekdayCalendarUnit fromDate:[NSDate date]];
    int weekday = [comps weekday];
    if(restaurant.openHours != nil
       && restaurant.openHours.count >0){
        [hours setText: [restaurant.openHours objectAtIndex:weekday]];
    }
    else{
        [hours setText: @""];
    }
}

- (void)handleSingleTap:(UITapGestureRecognizer *)recognizer {
    int newAlpha;
    if(!isBarVisible){
        newAlpha = 1;
        isBarVisible = YES;
        [self refreshBars];
    }
    else{
        newAlpha = 0;
        isBarVisible = NO;
    }
    
    [UIView beginAnimations:nil context:nil];
    [UIView setAnimationDuration:0.5];
    [UIView setAnimationCurve:UIViewAnimationCurveEaseOut];
    
    bottomBar.alpha = newAlpha;
    locationBar.alpha = newAlpha;
    
    [UIView commitAnimations];
}

- (void)handleSingleTapOnMenu:(UITapGestureRecognizer *)recognizer {
   
    UIScrollView *myScrollView = (UIScrollView*)[recognizer.view superview];
    UIImageView *myImageView = (UIImageView*)[recognizer view];
    
    float angle ;
    float stretch;
    float bottomOfImage;
    float vY;
    int offset;
    if (scrollView.contentOffset.x>=0) {
          offset = (scrollView.contentOffset.x-scrollViewOffset.x)/pageFrame.size.width;
    }
    else
    {
          offset = 0;
    }
   
    int ind = [self appdelegate].currentIndex + offset;

    
    
    
   
    if([isMenuTransformed[ind] boolValue] == NO){
//big image
        angle = -(3.0f * (3.14f / 100.0f));
        stretch = 2.5f;
        bottomOfImage = myImageView.center.y+(myImageView.frame.size.height)/2;
        vY = -(myScrollView.frame.size.height - bottomOfImage)*stretch;
        
        isMenuTransformed[ind] = @YES;
        [(UIScrollView*)[recognizer.view superview]setScrollEnabled:NO];
        [myScrollView setScrollEnabled:YES];
        
        
        [UIView beginAnimations:nil context:nil];
        [UIView setAnimationDuration:0.4];
        [UIView setAnimationCurve:UIViewAnimationCurveEaseOut];
        
        [(UIScrollView*)[recognizer.view superview] setContentOffset:CGPointMake(0, 0)];
    
        CGAffineTransform move = CGAffineTransformTranslate(myImageView.transform, 0, vY);
        CGAffineTransform scale = CGAffineTransformScale(move, stretch, stretch);
        CGAffineTransform rotate = CGAffineTransformRotate(scale, angle);
        myImageView.transform = rotate;
          [myImageView setFrame:CGRectMake(0, 0, myImageView.frame.size.width, myImageView.frame.size.height)];
        [(UIScrollView*)[recognizer.view superview] setContentOffset:CGPointMake(0, 0)];
        [UIView commitAnimations];
        
        
    }
    else{
//small image
        isMenuTransformed[ind] = @NO;
        
        angle = 3.0f * (3.14f / 100.0f);
        stretch = 0.399f;
        bottomOfImage = myImageView.center.y+(myImageView.frame.size.height*stretch)/2;
        vY = myScrollView.frame.size.height - bottomOfImage;
        
        
   
        
        [myScrollView setScrollEnabled:NO];
        
        
        [UIView beginAnimations:nil context:nil];
        [UIView setAnimationDuration:0.4];
        [UIView setAnimationCurve:UIViewAnimationCurveEaseOut];
        
        [(UIScrollView*)[recognizer.view superview] setContentOffset:CGPointMake(0, 0)];
        
        CGAffineTransform move = CGAffineTransformTranslate(myImageView.transform, 0, vY);
        CGAffineTransform scale = CGAffineTransformScale(move, stretch, stretch);
        CGAffineTransform rotate = CGAffineTransformRotate(scale, angle);
        myImageView.transform = rotate;
      
        [(UIScrollView*)[recognizer.view superview] setContentOffset:CGPointMake(0, 0)];
        [UIView commitAnimations];
        
        
        
    }
    
    
   
    
}

-(void)loadOtherRestaurants: (NSNumber*)index{
    //load next restaurants
    for(int i=index.intValue+1; i<restaurants.count; i++){
        if(restaurants.count > 0)
            [self loadRestaurantAtIndex: i];
        else
            break;
        
    }
    //load previous restaurants
    for(int i=index.intValue+1; i>=0; i--){
        if(restaurants.count > 0)
            [self loadRestaurantAtIndex: i];
        else
            break;
    }
    [self appdelegate].isHorizontalScreenLoaded=YES;
}



-(void)loadRestaurantAtIndex: (int)index{
    bool saveNewRestaurantJSON = NO;
    NSLog(@"restaurants.count :%d", restaurants.count);
    if( restaurants.count > 0 ){
        // dispatch_queue_t mainQueue = dispatch_get_main_queue();
        dispatch_queue_t queue;
        if(index == currentRestaurantIndex)
            queue = dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_HIGH, NULL);
        else{
            queue = dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_LOW, NULL);
        }
        dispatch_async( queue, ^{
            if(index < restaurants.count && index>=0){
                Restaurant *tempRestaurant = [restaurants objectAtIndex:index];

                NSURL *profileImageURL=nil;
                NSData *profileImageData=nil;
                
                NSString *cachesPath = [NSSearchPathForDirectoriesInDomains(NSCachesDirectory, NSUserDomainMask, YES) lastObject];
                NSString *imageName = [[[tempRestaurant city] stringByAppendingFormat:@"___%@",[tempRestaurant name]]
                                       stringByAppendingPathExtension:@"jpg"];
                NSString *cacheFile = [cachesPath stringByAppendingPathComponent: imageName];
       
                if([self appdelegate].isFindNearby){
                    if(![[NSFileManager defaultManager] fileExistsAtPath:cacheFile]){
                        profileImageURL = [NSURL URLWithString:[tempRestaurant profileImage]];
                        profileImageData = [NSData dataWithContentsOfURL:profileImageURL];
                        NSLog(@"Downloaded profile image displayed");
                        
                        NSDictionary * args = [NSDictionary dictionaryWithObjectsAndKeys:
                                               profileImageData, @"imageData",
                                               cacheFile, @"fileName",
                                               nil];
                        
                        [self performSelectorInBackground:@selector(saveImageFormData:) withObject:args];
                    }
                    else{
                        NSLog(@"Local profile image displayed");
                        profileImageData = [NSData dataWithContentsOfFile:cacheFile];
                    }
                }
                else{
                    if(![[NSFileManager defaultManager] fileExistsAtPath:cacheFile]
                       || [cachedRestaurants count] == 0
                       || cachedRestaurants == nil
                       ||![[tempRestaurant profileImage] isEqualToString:[[cachedRestaurants objectAtIndex:index] objectForKey:@"profileImage"]]){
                        profileImageURL = [NSURL URLWithString:[tempRestaurant profileImage]];
                        profileImageData = [NSData dataWithContentsOfURL:profileImageURL];
                        NSLog(@"Downloaded profile image displayed");
                        
                        NSDictionary * args = [NSDictionary dictionaryWithObjectsAndKeys:
                                               profileImageData, @"imageData",
                                               cacheFile, @"fileName",
                                               nil];
                        
                        [self performSelectorInBackground:@selector(saveImageFormData:) withObject:args];
                        [self setSaveNewRestaurantJSON: YES];
                    }
                    else{
                        NSLog(@"Local profile image displayed");
                        profileImageData = [NSData dataWithContentsOfFile:cacheFile];
                    }
                }
                
                
                
                NSURL *menuImageURL =[NSURL URLWithString:[tempRestaurant menuImage]];
                NSData *menuImageData = [NSData dataWithContentsOfURL:menuImageURL];
                isMenuTransformed[index]= @NO;
                
                dispatch_sync( dispatch_get_main_queue(), ^{
                    //background image
                    UIImage *profileImage;
                    if(profileImageData != nil)
                        profileImage= [UIImage imageWithData:profileImageData];
                    else
                        profileImage = [UIImage imageNamed:@"default_main.png"];
                    
                    UIImageView *bgImageView = [[UIImageView alloc] initWithFrame:bgFrame];
                    [bgImageView setContentMode:UIViewContentModeScaleAspectFit];
                    [bgImageView setImage:profileImage];
                    
                    
                    UITapGestureRecognizer *singleTapGestureRecognizer = [[UITapGestureRecognizer alloc]
                                                                          initWithTarget:self
                                                                          action:@selector(handleSingleTap:)];
                    [singleTapGestureRecognizer setNumberOfTapsRequired:1];
                    [[pages objectAtIndex: index] addGestureRecognizer:singleTapGestureRecognizer];
                    [[pages objectAtIndex: index] addSubview:bgImageView];
                    
                    UIImage *menuImage = [UIImage imageWithData:menuImageData];
//                    UIImage * frame= [UIImage imageNamed:@"menu_ramka.png"];
                    
                    int menuImageWidth = floor(scrollView.frame.size.width/1.6);
                    
                   
                    float height;
                    if(menuImage.size.width!=0)
                        height=floor(menuImage.size.height/(menuImage.size.width/menuImageWidth));
                    else
                        height = 0;
                    
                    CGRect menuFrame = CGRectMake(7,
                                                  0,
                                                  menuImageWidth,
                                                  height);
                    
                    UIImageView *menuImageView = [[UIImageView alloc] initWithFrame:menuFrame];
                    [menuImageView setContentMode:UIViewContentModeScaleAspectFit];
                    UIGraphicsEndImageContext();
                    
                    
                    
                    //
                    
                    
                    [menuImageView setImage:menuImage];
                    [menuImageView setUserInteractionEnabled:YES];
                    
                    UIColor * col=[UIColor colorWithRed:158.0f/255.0f green:150.0f/255.0f blue:152.0f/255.0f alpha:1.0f];
                    
                    
                    CALayer *layer = menuImageView.layer;
                    [layer setBorderColor:[col CGColor]];
                    [layer setBorderWidth:6.0f];
                    [layer setShadowColor: [[UIColor blackColor] CGColor]];
                    [layer setShadowOpacity:0.9f];
                    [layer setShadowOffset: CGSizeMake(1, 3)];
                    [layer setShadowRadius:8.0];
                    [menuImageView setClipsToBounds:NO];
                    
                    
                    CGRect menuScrollFrame = CGRectMake(scrollView.frame.size.width - menuImageWidth,
                                                        0,
                                                        menuImageWidth,
                                                        scrollView.frame.size.height);
                    
                    UIScrollView *menuScrollView = [[UIScrollView alloc] init];
                    [menuScrollView setFrame:menuScrollFrame];
                    
                    UITapGestureRecognizer *singleTapGestureRecognizer_menu = [[UITapGestureRecognizer alloc]
                                                                               initWithTarget:self
                                                                               action:@selector(handleSingleTapOnMenu:)];
                    [singleTapGestureRecognizer_menu setNumberOfTapsRequired:1];
                    [menuImageView addGestureRecognizer:singleTapGestureRecognizer_menu];
                  
                    [menuScrollView addSubview:menuImageView];
                    
                    [menuScrollView setContentSize:menuImageView.frame.
                     size];
                    [menuScrollView setContentOffset:CGPointMake(0, 0)];
                    [menuScrollView setShowsHorizontalScrollIndicator:NO];
                    [menuScrollView setShowsVerticalScrollIndicator:NO];
                    [menuScrollView setScrollEnabled:NO];
                    
                    float angle = 3.0f * (3.14f / 100.0f);
                    float stretch = 0.399f;
                    int bottomOfImage = menuImageView.center.y+(menuImageView.frame.size.height*stretch)/2;
                    int vY = menuScrollView.frame.size.height - bottomOfImage;
                    NSLog(@"bottom: %d  ||  vY: %d", bottomOfImage, vY);
                    CGAffineTransform move = CGAffineTransformTranslate(menuImageView.transform, 0, vY);
                    CGAffineTransform scale = CGAffineTransformScale(move, stretch, stretch);
                    CGAffineTransform rotate = CGAffineTransformRotate(scale, angle);
                    menuImageView.transform = rotate;
                    
                    [[pages objectAtIndex: index] addSubview:menuScrollView];
                    [spinner stopAnimating];
                });
            }
        });
    }
    
    if(saveNewRestaurantJSON){
        [connManager updateDistrictJSON];
    }
}


-(void) saveImageFormData:(NSDictionary*) args{
    if([args objectForKey:@"imageData"] != nil){
        UIImage *image =[[UIImage alloc]initWithData:[args objectForKey:@"imageData"]];
        [UIImageJPEGRepresentation(image, 1.0) writeToFile:[args objectForKey:@"fileName"] options:nil error:nil];
    }
    else
        NSLog(@"Empty file");
}


-(void)prepareRestaurantsViews{
    for(int i=0; i<pages.count; i++){
        [[pages objectAtIndex:i] removeFromSuperview];
    }
    
    isMenuTransformed = [[NSMutableArray alloc] initWithCapacity:kNumberOfPages];
    for(int i=0; i<kNumberOfPages; i++){
        isMenuTransformed[i] = @NO;
        pageFrame.origin.x = scrollView.frame.size.width * (i);
        pageFrame.origin.y = 0;
        pageFrame.size = scrollView.frame.size;
        
        UIView *page = [[UIView alloc] initWithFrame:pageFrame];
        [scrollView addSubview:page];
    }
    scrollView.contentSize = CGSizeMake(scrollView.frame.size.width * (kNumberOfPages), scrollView.frame.size.height);
    pages = [scrollView subviews];
}

-(void)loadCurrentRestaurant: (int)index{
    [scrollView setContentOffset: CGPointMake(scrollView.frame.size.width*index, 0)];
    
    [self loadRestaurantAtIndex: currentRestaurantIndex];
}

- (IBAction)call:(id)sender {
    
    NSLog(@"%@",[[restaurants objectAtIndex:currentRestaurantIndex] name]);
    
    UIDevice *device = [UIDevice currentDevice];
    
    if ([[device model] isEqualToString:@"iPhone"] ) {
        
        if (![[[restaurants objectAtIndex:currentRestaurantIndex] phoneRestaurant]isEqualToString:@""]) {
            
            NSString *str = [[restaurants objectAtIndex:currentRestaurantIndex] phoneRestaurant];
            
            
            
            str = [str stringByReplacingOccurrencesOfString:@" "
                   
                                                 withString:@""];
            
            
            
            str = [str stringByReplacingOccurrencesOfString:@"-"
                   
                                                 withString:@""];
            
            
            
            str = [str stringByReplacingOccurrencesOfString:@"."
                   
                                                 withString:@""];
            
            
            
            str = [str stringByReplacingOccurrencesOfString:@":"
                   
                                                 withString:@""];
            
            
            
            
            
            NSString *phoneNumber = [@"telprompt://" stringByAppendingString:str];
            
            [[UIApplication sharedApplication] openURL:[NSURL URLWithString:phoneNumber]];
            
            
            
            
            
        }
        
        else
            
        {
            
            UIAlertView *Notpermitted=[[UIAlertView alloc] initWithTitle:@""
                                       
                                                                 message: NSLocalizedString(@"NoNumber", nil)
                                       
                                                                delegate:nil
                                       
                                                       cancelButtonTitle:NSLocalizedString(@"OkButton", nil)
                                       
                                                       otherButtonTitles:nil];
            
            [Notpermitted show];
            
        }
        
        
        
    } else {
        
        UIAlertView *Notpermitted=[[UIAlertView alloc] initWithTitle:@""
                                   
                                                             message:NSLocalizedString(@"NotSupported Feature", nil)
                                   
                                                            delegate:nil
                                   
                                                   cancelButtonTitle:NSLocalizedString(@"OkButton", nil)
                                   
                                                   otherButtonTitles:nil];
        
        [Notpermitted show];
        
        
        
    }
    
}

- (IBAction)goToMap:(id)sender {
    mapController=[self.storyboard instantiateViewControllerWithIdentifier:@"map" ];
    Restaurant*temp=[connManager.restaurants objectAtIndex:currentRestaurantIndex ];
    mapController.restaurant=temp;
    mapController.distance=distance.text;
    [self animateViewChange];
    [self.navigationController pushViewController:mapController animated:TRUE];
    
}



-(void)updateIndex{
    if(scrollView.contentOffset.x > scrollViewOffset.x){
        int offset = (scrollView.contentOffset.x-scrollViewOffset.x)/pageFrame.size.width;
        [self appdelegate].currentIndex += offset;
        NSLog(@"page + %d", offset);
    }
    else if(scrollView.contentOffset.x < scrollViewOffset.x){
        int offset = (scrollViewOffset.x-scrollView.contentOffset.x)/pageFrame.size.width;
        [self appdelegate].currentIndex -= offset;
        NSLog(@"page - %d", offset);
    }
}


-(void)animateViewChange{
    CATransition* transition = [CATransition animation];
    transition.duration = 0.4;
    transition.type = kCATransitionFade;
    transition.subtype = kCATransitionFromTop;
    [self.navigationController.view.layer
     addAnimation:transition forKey:kCATransition];
}


- (void)willRotateToInterfaceOrientation:(UIInterfaceOrientation)toInterfaceOrientation duration:(NSTimeInterval)duration
{
    [UIView setAnimationsEnabled:NO]; // disable animations temporarily
}

- (void)didRotateFromInterfaceOrientation:(UIInterfaceOrientation)fromInterfaceOrientation
{
    [UIView setAnimationsEnabled:YES]; // rotation finished, re-enable them
}


-(BOOL)shouldAutorotate{
    UIInterfaceOrientation interfaceOrientation = [[UIDevice currentDevice] orientation];
    return interfaceOrientation==UIInterfaceOrientationPortrait || interfaceOrientation==UIInterfaceOrientationPortraitUpsideDown;
}

- (NSUInteger)supportedInterfaceOrientations{
    return UIInterfaceOrientationMaskAll;
}

- (void)willAnimateRotationToInterfaceOrientation:(UIInterfaceOrientation)  interfaceOrientation duration:(NSTimeInterval)duration
{
    [self shouldAutorotateToInterfaceOrientation:[[UIDevice currentDevice] orientation]];
    
}


- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    if(interfaceOrientation==UIInterfaceOrientationPortrait || interfaceOrientation==UIInterfaceOrientationPortraitUpsideDown)
    {
        [self updateIndex];
        
        [self animateViewChange];
        [[self navigationController] popViewControllerAnimated:NO];
        return NO;
    }
    return YES;
}


//



- (void)actionSheet:(UIActionSheet *)actionSheet clickedButtonAtIndex:(NSInteger)buttonIndex {
    if(buttonIndex==0)
    {
        if ([MFMailComposeViewController canSendMail])
        {
            Restaurant *temp=[restaurants objectAtIndex:currentRestaurantIndex];
            NSString* someText = [NSString stringWithFormat:@"%@ %@", NSLocalizedString(@"MAILBODY", nil),temp.address];
            
            
            MFMailComposeViewController *mailer = [[MFMailComposeViewController alloc] init];
            mailer.mailComposeDelegate = self;
            [mailer setSubject:NSLocalizedString(@"MailSubject", nil)];
            
            UIImage *myImage = temp.downloadedMainImage;
            NSData *imageData = UIImagePNGRepresentation(myImage);
            [mailer addAttachmentData:imageData mimeType:@"image/png" fileName:@"main"];
            
            UIImage *myImage2 = temp.downloadedMenuImage;
            NSData *imageData2 = UIImagePNGRepresentation(myImage2);
            [mailer addAttachmentData:imageData2 mimeType:@"image/png" fileName:@"menu"];
            
            
            NSString *emailBody = someText;
            [mailer setMessageBody:emailBody isHTML:NO];
            [self presentModalViewController:mailer animated:YES];
        }
        else
        {
            UIAlertView *alert = [[UIAlertView alloc] initWithTitle:NSLocalizedString(@"Failure", nil)
                                                            message:NSLocalizedString(@"MComposerNot Supported", nil)
                                                           delegate:nil
                                                  cancelButtonTitle:NSLocalizedString(@"OkButton", nil)
                                                  otherButtonTitles:nil];;
            
            [alert show];
            
        }
    }
    else if (buttonIndex==1)
    {
        MFMessageComposeViewController *controller = [[MFMessageComposeViewController alloc] init];
        if([MFMessageComposeViewController canSendText])
        {
            Restaurant* shownRestaurant=[restaurants objectAtIndex:currentRestaurantIndex];
            NSString* someText = shownRestaurant.name;
            controller.body =someText;
            controller.recipients = [NSArray arrayWithObjects:@"", nil];
            controller.messageComposeDelegate = self;
            controller.delegate = self;
            [self presentModalViewController:controller animated:YES];
        }
    }
    else if (buttonIndex==2)
    {
        [self sendEasyTweet:nil];
    }
    else if (buttonIndex==3)
    {
        
        
        [self openSession];
    }
}

- (IBAction)sendEasyTweet:(id)sender {
    // Set up the built-in twitter composition view controller.
    TWTweetComposeViewController *tweetViewController = [[TWTweetComposeViewController alloc] init];
    Restaurant*t=[restaurants objectAtIndex:currentRestaurantIndex];
    // Set the initial tweet text. See the framework for additional properties that can be set.
    NSString * content=[NSString stringWithFormat:@"Come here. It's a great restaurant! %@  at %@",t.name,t.address];
    [tweetViewController setInitialText:content];
    [tweetViewController addImage:t.downloadedMainImage];
    [tweetViewController addImage:t.downloadedMenuImage];
    // Create the completion handler block.
    [tweetViewController setCompletionHandler:^(TWTweetComposeViewControllerResult result) {
        NSString *output;
        
        switch (result) {
            case TWTweetComposeViewControllerResultCancelled:
                // The cancel button was tapped.
                output = @"Tweet cancelled.";
                break;
            case TWTweetComposeViewControllerResultDone:
                // The tweet was sent.
                output = @"Tweet done.";
                break;
            default:
                break;
        }
        
        // [self performSelectorOnMainThread:@selector(displayText:) withObject:output waitUntilDone:NO];
        
        // Dismiss the tweet composition view controller.
        [self dismissModalViewControllerAnimated:YES];
    }];
    
    // Present the tweet composition view controller modally.
    [self presentModalViewController:tweetViewController animated:YES];
}


- (void) performPublishAction:(void (^)(void)) action {
    NSLog(@"wywolano");
    // we defer request for permission to post to the moment of post, then we check for the permission
    if ([FBSession.activeSession.permissions indexOfObject:@"publish_actions"] == NSNotFound) {
        // if we don't already have the permission, then we request it now
        [FBSession.activeSession requestNewPublishPermissions:@[@"publish_actions"]
                                              defaultAudience:FBSessionDefaultAudienceFriends
                                            completionHandler:^(FBSession *session, NSError *error) {
                                                if (!error) {
                                                    action();
                                                }
                                                //For this example, ignore errors (such as if user cancels).
                                            }];
    } else {
        action();    }
    
}

- (IBAction)postPhotoClick:(UIButton *)sender {
    // Just use the icon image from the application itself.  A real app would have a more
    // useful way to get an image.
    UIImage *img = [[restaurants objectAtIndex:currentRestaurantIndex] downloadedMenuImage];
    
    // if it is available to us, we will post using the native dialog
    //    BOOL displayedNativeDialog = [FBNativeDialogs presentShareDialogModallyFrom:self
    //                                                                    initialText:nil
    //                                                                          image:img
    //                                                                            url:nil
    //                                                                        handler:nil];
    //    if (!displayedNativeDialog) {
    
    
    [self performPublishAction:^{
        
        [FBRequestConnection startForUploadPhoto:img
                               completionHandler:^(FBRequestConnection *connection, id result, NSError *error) {
                                   
                                   [self postStatusUpdateClick:nil];
                               }];
        
    }];
    
}
//}

- (IBAction)postStatusUpdateClick:(UIButton *)sender {
    // Post a status update to the user's feed via the Graph API, and display an alert view
    // with the results or an error.
    
    // if it is available to us, we will post using the native dialog
    BOOL displayedNativeDialog = [FBNativeDialogs presentShareDialogModallyFrom:self
                                                                    initialText:nil
                                                                          image:nil
                                                                            url:nil
                                                                        handler:nil];
    
    if (!displayedNativeDialog) {
        Restaurant*t=[restaurants objectAtIndex:currentRestaurantIndex];
        [self performPublishAction:^{
            // otherwise fall back on a request for permissions and a direct post
            NSString *message = [NSString stringWithFormat:@"Come to restaurant %@ at %@",t.name, t.address];
            
            [FBRequestConnection startForPostStatusUpdate:message
                                        completionHandler:^(FBRequestConnection *connection, id result, NSError *error) {
                                            
                                            UIAlertView*alert=[[UIAlertView alloc]initWithTitle:NSLocalizedString(@"Success", nil) message:NSLocalizedString(@"Post Uploaded", nil) delegate:nil cancelButtonTitle:NSLocalizedString(@"Ok", nil) otherButtonTitles:nil, nil];
                                            [alert show];
                                            
                                        }];
            
            
        }];
    }
}
- (void)sessionStateChanged:(FBSession *)session
                      state:(FBSessionState) state
                      error:(NSError *)error
{
    switch (state) {
        case FBSessionStateOpen: {
            NSLog(@"poszlo ok");
            [self postPhotoClick:nil];
            
        }
            break;
        case FBSessionStateClosed:
        case FBSessionStateClosedLoginFailed:
        {
            NSLog(@"poszlo zle");
        }
            
            [FBSession.activeSession closeAndClearTokenInformation];
            
            
            break;
        default:
            break;
    }
    
    if (error) {
        UIAlertView *alertView = [[UIAlertView alloc]
                                  initWithTitle:NSLocalizedString(@"Error", nil)
                                  message:error.localizedDescription
                                  delegate:nil
                                  cancelButtonTitle:NSLocalizedString(@"OkButton", nil)
                                  otherButtonTitles:nil];
        [alertView show];
    }
}
- (BOOL)application:(UIApplication *)application
            openURL:(NSURL *)url
  sourceApplication:(NSString *)sourceApplication
         annotation:(id)annotation
{
    return [FBSession.activeSession handleOpenURL:url];
}

- (void)openSession
{
    [FBSession openActiveSessionWithReadPermissions:nil
                                       allowLoginUI:YES
                                  completionHandler:
     ^(FBSession *session,
       FBSessionState state, NSError *error) {
         [self sessionStateChanged:session state:state error:error];
     }];
}
- (void)mailComposeController:(MFMailComposeViewController*)controller didFinishWithResult:(MFMailComposeResult)result error:(NSError*)error
{
    switch (result)
    {
        case MFMailComposeResultCancelled:
            NSLog(@"Mail cancelled: you cancelled the operation and no email message was queued.");
            break;
        case MFMailComposeResultSaved:
            NSLog(@"Mail saved: you saved the email message in the drafts folder.");
            break;
        case MFMailComposeResultSent:
            NSLog(@"Mail send: the email message is queued in the outbox. It is ready to send.");
            break;
        case MFMailComposeResultFailed:
            NSLog(@"Mail failed: the email message was not saved or queued, possibly due to an error.");
            break;
        default:
            NSLog(@"Mail not sent.");
            break;
    }
    // Remove the mail view
    [self dismissModalViewControllerAnimated:YES];
}

- (IBAction)send:(id)sender {
    
    
  
        NSString *actionSheetTitle = @""; //Action Sheet Title
        NSString *other1 = @"";
        NSString *other2 = @"";
        NSString *other3 = @"";
        NSString *other4 = @"";
        NSString *cancelTitle = @"Cancel";
        UIActionSheet *actionSheet = [[UIActionSheet alloc]
                                      initWithTitle:actionSheetTitle
                                      delegate:self
                                      cancelButtonTitle:cancelTitle
                                      destructiveButtonTitle:nil
                                      otherButtonTitles:other1, other2, other3,other4, nil];
        actionSheet.actionSheetStyle=UIActionSheetStyleBlackOpaque;
        [actionSheet showInView:self.view];
        actionSheet.alpha=0.9;// setAlpha:0.8];
        
        
        UIButton*temp=[[actionSheet subviews]objectAtIndex:1];
        [temp setBackgroundImage:[UIImage imageNamed:@"email.png"] forState:UIControlStateNormal];
        [temp setBackgroundImage:[UIImage imageNamed:@"email2.png"] forState:UIControlStateHighlighted];
        [temp setBounds:CGRectMake(0, 0, 65, 65)];
        [temp setBackgroundColor:[UIColor blackColor]];
        [temp setCenter:CGPointMake(self.view.frame.size.width/5, 66)];
        [temp setBackgroundColor:[UIColor clearColor]];
        UIFont* font=[UIFont fontWithName:@"Helvetica-Bold" size:12.0];
        UILabel*title=[[UILabel alloc]initWithFrame:CGRectMake(0, 68, 65, 12)];
        [title setTextAlignment:NSTextAlignmentCenter];
        title.font=font;
        title.text=@"Mail";
        title.backgroundColor=[UIColor clearColor];
        title.textColor=[UIColor whiteColor];
        [temp addSubview:title];
        
        
        UIButton*temp2=[[actionSheet subviews]objectAtIndex:2];
        [temp2 setBackgroundImage:[UIImage imageNamed:@"message.png"] forState:UIControlStateNormal];
        [temp2 setBackgroundImage:[UIImage imageNamed:@"message2.png"] forState:UIControlStateHighlighted];
        [temp2 setBounds:CGRectMake(0, 0, 60, 60)];
        [temp2 setBackgroundColor:[UIColor blackColor]];
        [temp2 setCenter:CGPointMake(self.view.frame.size.width/5*2, 65)];
        [temp2 setBackgroundColor:[UIColor clearColor]];
        UILabel*title2=[[UILabel alloc]initWithFrame:CGRectMake(0, 65, 60, 12)];
        [title2 setTextAlignment:NSTextAlignmentCenter];
        title2.font=font;
        title2.text=@"Message";
        title2.backgroundColor=[UIColor clearColor];
        title2.textColor=[UIColor whiteColor];
        [temp2 addSubview:title2];
        
        UIButton*temp3=[[actionSheet subviews]objectAtIndex:3];
        [temp3 setBackgroundImage:[UIImage imageNamed:@"twitter.png"] forState:UIControlStateNormal];
        [temp3 setBackgroundImage:[UIImage imageNamed:@"twitter2.png"] forState:UIControlStateHighlighted];
        [temp3 setBounds:CGRectMake(0, 0, 60, 60)];
        [temp3 setBackgroundColor:[UIColor blackColor]];
        [temp3 setCenter:CGPointMake(self.view.frame.size.width/5*4, 65)];
        [temp3 setBackgroundColor:[UIColor clearColor]];
        UILabel*title3=[[UILabel alloc]initWithFrame:CGRectMake(0, 65, 60, 12)];
        [title3 setTextAlignment:NSTextAlignmentCenter];
        title3.font=font;
        title3.text=@"Twitter";
        title3.backgroundColor=[UIColor clearColor];
        title3.textColor=[UIColor whiteColor];
        [temp3 addSubview:title3];
        
        UIButton*temp4=[[actionSheet subviews]objectAtIndex:4];
        [temp4 setBackgroundImage:[UIImage imageNamed:@"facebook.png"] forState:UIControlStateNormal];
        [temp4 setBackgroundImage:[UIImage imageNamed:@"facebook2.png"] forState:UIControlStateHighlighted];
        [temp4 setBounds:CGRectMake(0, 0, 60, 60)];
        [temp4 setBackgroundColor:[UIColor blackColor]];
        [temp4 setCenter:CGPointMake(self.view.frame.size.width/5*3, 65)];
        [temp4 setBackgroundColor:[UIColor clearColor]];
        UILabel*title4=[[UILabel alloc]initWithFrame:CGRectMake(0, 65, 60, 12)];
        [title4 setTextAlignment:NSTextAlignmentCenter];
        title4.font=font;
        title4.text=@"Facebook";
        title4.backgroundColor=[UIColor clearColor];
        title4.textColor=[UIColor whiteColor];
        [temp4 addSubview:title4];
        
        
        
    
}

@end
