//
//  SingleScrollViewController.h
//  MenuMenu
//
//  Created by Pawel Ferens on 2/27/13.
//  Copyright (c) 2013 Pawel Ferens. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "Restaurant.h"
#import <MessageUI/MessageUI.h>
#import "MapViewController.h"
#import <CoreLocation/CoreLocation.h>
#import "LocationManager.h"
#import "RestaurantsHorizontalViewController.h"
#import <FacebookSDK/FacebookSDK.h>
#import <Twitter/Twitter.h>
#import <Accounts/Accounts.h>   
#import "InfoViewController.h"
#import "ConnectionManager.h"
@interface SingleScrollViewController : UIViewController<UIScrollViewDelegate,MFMailComposeViewControllerDelegate,CLLocationManagerDelegate,MFMessageComposeViewControllerDelegate,UINavigationControllerDelegate,UIActionSheetDelegate,FBLoginViewDelegate>
{
    RestaurantsHorizontalViewController *restaurantsHorizontalView;
}
@property (strong, nonatomic) IBOutlet UIImageView *topBar;
@property (strong, nonatomic) IBOutlet UIScrollView *scrollView;
@property(nonatomic,retain)NSMutableArray* restaurants;
@property int imageWidth;
@property int marigin;
@property int screenWidth;
@property int screenHeigth;
@property (strong, nonatomic) IBOutlet UIImageView *rightBar;
@property (strong, nonatomic) IBOutlet UIImageView *leftBar;
@property int pos;
- (IBAction)goBack:(id)sender;
- (IBAction)goToDistrictView:(id)sender;

@property (strong, nonatomic) IBOutlet UILabel *cityLabel;
@property(nonatomic,retain)NSString* cityName;
@property (strong, nonatomic) IBOutlet UIImageView *popupTop;
@property (strong, nonatomic) IBOutlet UILabel *restNameLabel;
@property (strong, nonatomic) IBOutlet UIImageView *line;
@property (strong, nonatomic) IBOutlet UIImageView *locationIcon;
@property (strong, nonatomic) IBOutlet UILabel *distanceLabel;
@property (strong, nonatomic) IBOutlet UIImageView *timeIcon;
@property (strong, nonatomic) IBOutlet UILabel *restAddressLabel;
@property (strong, nonatomic) IBOutlet UIImageView *popupBottom;
@property (strong, nonatomic) IBOutlet UIImageView *fullScreenMenuImageView;
@property (nonatomic, retain) UIImageView * imageToZoom;
@property (strong, nonatomic) IBOutlet UIScrollView *fullScreenMenuScrollView;
@property(nonatomic,retain)UIActivityIndicatorView* spinner;
@property bool isPopupShowed;

@property int index;
@property (strong, nonatomic) IBOutlet UIButton *callButton;

@property (strong, nonatomic) IBOutlet UIButton *mapButton;

@property (strong, nonatomic) IBOutlet UIButton *sendButton;

- (IBAction)send:(id)sender;
- (IBAction)goToMap:(id)sender;
- (IBAction)call:(id)sender;

@property int actualRestaurantIndex;
@property(nonatomic , retain)MapViewController* mapController;

- (IBAction)changeOrientation:(id)sender;
@property InfoViewController* infoViewController;
@end
