//
//  SingleScrollViewController.m
//  MenuMenu
//
//  Created by Pawel Ferens on 2/27/13.
//  Copyright (c) 2013 Pawel Ferens. All rights reserved.
//

#import "SingleScrollViewController.h"

@interface SingleScrollViewController ()

@end

@implementation SingleScrollViewController
@synthesize restaurants;
@synthesize scrollView;
@synthesize marigin;
@synthesize imageWidth;
@synthesize screenWidth;
@synthesize leftBar;
@synthesize rightBar;
@synthesize pos;
@synthesize cityLabel;
@synthesize cityName;
@synthesize popupBottom;
@synthesize popupTop;
@synthesize distanceLabel;
@synthesize line;
@synthesize locationIcon;
@synthesize restAddressLabel;
@synthesize timeIcon;
@synthesize topBar;
@synthesize restNameLabel;
@synthesize index;
@synthesize fullScreenMenuImageView;
@synthesize spinner;
@synthesize fullScreenMenuScrollView;
@synthesize sendButton;
@synthesize actualRestaurantIndex;
@synthesize mapController;
@synthesize imageToZoom;
@synthesize isPopupShowed;
@synthesize infoViewController;
//@synthesize sendLabel;
@synthesize callButton;
//@synthesize callLabel;
@synthesize mapButton;

//@synthesize mapLabel;




- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

-(void)messageComposeViewController:(MFMessageComposeViewController *)controller didFinishWithResult:(MessageComposeResult)result
{
    [self dismissModalViewControllerAnimated:YES];
}
- (void)viewDidLoad
{
    
    [super viewDidLoad];
    
    
    
    isPopupShowed=NO;
    restaurantsHorizontalView=[self.storyboard instantiateViewControllerWithIdentifier:@"restaurantsHorizontalView" ];
     infoViewController=[self.storyboard instantiateViewControllerWithIdentifier:@"info" ];
    screenWidth=self.view.frame.size.width;
    int screenHeigth=self.view.frame.size.height;
    marigin=20;
    imageWidth=screenWidth-leftBar.frame.size.width-rightBar.frame.size.width-2*marigin;
    NSLog(@" image width in single scrollview : %d",imageWidth);
    [scrollView setDelegate:self];
    spinner=[[UIActivityIndicatorView alloc]initWithActivityIndicatorStyle:UIActivityIndicatorViewStyleWhiteLarge];
    [spinner setFrame:CGRectMake(screenWidth/2-15, screenHeigth/2-15, 30, 30)];
    
    [self.view addSubview:spinner];
    
    UITapGestureRecognizer *doubleTapGestureRecognizer = [[UITapGestureRecognizer alloc]
                                                          initWithTarget:self action:@selector(closeFullScreenView:)];
    
    
    self.fullScreenMenuScrollView.minimumZoomScale=fullScreenMenuScrollView.frame.size.height / fullScreenMenuImageView.frame.size.height;
    self.fullScreenMenuScrollView.maximumZoomScale=5.0;
    self.fullScreenMenuScrollView.delegate=self;
    doubleTapGestureRecognizer.numberOfTapsRequired = 2;
    
    [fullScreenMenuScrollView addGestureRecognizer:doubleTapGestureRecognizer];
    
    
    fullScreenMenuImageView.userInteractionEnabled = YES;
	// Do any additional setup after loading the view.
}
-(void)closeFullScreenView:(id)sender
{
    [UIView beginAnimations:nil context:nil];
    [UIView setAnimationDuration:0.5];
    [UIView setAnimationCurve:UIViewAnimationCurveEaseOut];
    [fullScreenMenuImageView setAlpha:0.0f];
    [fullScreenMenuScrollView setAlpha:0.0f];
    [UIView commitAnimations];
    
}

-(void)viewWillAppear:(BOOL)animated{
    [[UIDevice currentDevice] setOrientation:UIInterfaceOrientationPortrait];
    [self appdelegate].rotateToLandScape=YES;
}

-(void)viewDidAppear:(BOOL)animated
{
    [distanceLabel setAlpha:0.0f];
    [restAddressLabel setAlpha:0.0f];
    [restNameLabel setAlpha:0.0f];
    [locationIcon setAlpha:0.0f];
    [timeIcon setAlpha:0.0f];
    [line setAlpha:0.0f];
    [callButton setAlpha:0.0f];
    [mapButton setAlpha:0.0f];
    [sendButton setAlpha:0.0f];
    
    LocationManager*managerL=[LocationManager getInstance];
    [managerL getLocation];
    
    pos=70;
    [popupBottom setAlpha:0.0f];
    [popupTop setAlpha:0.0f];
    self.cityLabel.text=cityName;
    
    [UIView setAnimationsEnabled:YES];
    
    // if (![[self appdelegate]isRestaurantsScreenLoaded]) {
    
    for(UIView *subview in [scrollView subviews]) {
        [subview removeFromSuperview];
    }
    
    
    for(int i=0;i<[restaurants count];i++)
    {
        Restaurant*temp= [restaurants objectAtIndex:i];
        NSLog(@"%@",temp.name);
        UIImage*p=temp.downloadedMainImage;
        if (p!=nil) {
            float r=p.size.width/p.size.height;
            UIButton*t= [[UIButton alloc]initWithFrame:CGRectMake(marigin+leftBar.frame.size.width, pos, imageWidth, imageWidth/r)];
            [t addTarget:self action:@selector(showPopup:) forControlEvents:UIControlEventTouchUpInside];
            [t setBackgroundImage:p forState:UIControlStateNormal];
            [t setTag:i+2000];
            t.adjustsImageWhenHighlighted=NO;
            pos=pos+imageWidth/r;
            [self.scrollView addSubview:t];
        }
        
        UIImage*po=temp.downloadedMenuImage;
        if(po==nil)
            po=[UIImage imageNamed:@"menu_empty.jpg"];
        
        // if (po!=nil) {
        
        float ro=po.size.width/po.size.height;
        
        UIButton*to= [[UIButton alloc]initWithFrame:CGRectMake(marigin+leftBar.frame.size.width, pos, imageWidth, imageWidth/ro)];
        [to addTarget:self action:@selector(showPopup:) forControlEvents:UIControlEventTouchUpInside];
        
        [to setBackgroundImage:po forState:UIControlStateNormal];
        [to setTag:i+1000];
        to.adjustsImageWhenHighlighted=NO;
        UITapGestureRecognizer *doubleTapGestureRecognizer = [[UITapGestureRecognizer alloc]
                                                              initWithTarget:self action:@selector(handleDoubleTap:)];
        
        doubleTapGestureRecognizer.numberOfTapsRequired = 2;
        
        [to addGestureRecognizer:doubleTapGestureRecognizer];
        
        pos=pos+imageWidth/ro+marigin;
        
        [self.scrollView addSubview:to];
        // }
        
    }
    [scrollView setContentSize:CGSizeMake(screenWidth, pos)];
    NSLog(@"currentIndex: %d", [self appdelegate].currentIndex);
    int tag=0;
    if(![self appdelegate].isFindNearby){
        tag = [self appdelegate].currentIndex+2000;
    }
    else{
        tag = [self appdelegate].currentIndex;
    }
    UIButton*x=(UIButton*)[scrollView viewWithTag:tag];
    [scrollView setContentOffset:CGPointMake(0, x.frame.origin.y)];
    
    
    for(int i=0;i<[restaurants count];i++)
    {
        if ([restaurants count]>0) {
            dispatch_async( dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
            Restaurant*temp= [restaurants objectAtIndex:i];
            NSString*blobEnding=temp.menuImageScreenSize;
            NSURL *url = [NSURL URLWithString:blobEnding];
            NSData *data = [NSData dataWithContentsOfURL:url];
            UIImage*imageNew=[[UIImage alloc]initWithData:data];
            //    NSLog(@"%@",temp.menuImageScreenSize);
            
            dispatch_async( dispatch_get_main_queue(), ^{
                
                if (imageNew!=nil) {
                    UIButton* but=(UIButton*)[scrollView viewWithTag:i+1000];
                    // [but setAlpha:0.5f];
                    [but setBackgroundImage:imageNew forState:UIControlStateNormal];
                    Restaurant    *   temp=[restaurants objectAtIndex:i];
                    
                    temp.downloadedMenuImage=imageNew;                 //if there will be issue with lack of memory, comment this line
                }
            });
        });
        }
    }
}

- (UIView *)viewForZoomingInScrollView:(UIScrollView *)scrollView{
    //return self.fullScreenMenuImageView;
    return self.imageToZoom;
}


-(BOOL)isPad
{
#ifdef UI_USER_INTERFACE_IDIOM
    return UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad;
#endif
    return NO;
}

-(void)handleDoubleTap:(UITapGestureRecognizer*)sender
{
    for(UIView *subview in [fullScreenMenuScrollView subviews]) {
        [subview removeFromSuperview];
    }
    imageToZoom=[[UIImageView alloc]initWithImage:[[restaurants objectAtIndex:(sender.view.tag-1000)]downloadedMenuImage]];
    [imageToZoom setFrame:CGRectMake(0, 0, fullScreenMenuScrollView.frame.size.width, fullScreenMenuScrollView.frame.size.height)];
    [imageToZoom setContentMode: UIViewContentModeScaleAspectFit];
    [fullScreenMenuScrollView setContentSize:CGSizeMake(fullScreenMenuScrollView.frame.size.width, fullScreenMenuScrollView.frame.size.height)];
    [fullScreenMenuScrollView addSubview:imageToZoom];
   
    [fullScreenMenuScrollView setUserInteractionEnabled:NO];
    [spinner startAnimating];
    NSLog(@"double tap");
    [UIView beginAnimations:nil context:nil];
    [UIView setAnimationDuration:0.5];
    [UIView setAnimationCurve:UIViewAnimationCurveEaseOut];
    
    
    dispatch_async( dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
        
        NSString*blobEnding2=[[restaurants objectAtIndex:(sender.view.tag-1000)] menuImageScaleSize];
        NSURL *url1 = [NSURL URLWithString:blobEnding2];
        NSData *data1 = [NSData dataWithContentsOfURL:url1];
        
        UIImage* temp=[[UIImage alloc]initWithData:data1];;
        
        dispatch_async( dispatch_get_main_queue(), ^{
            if(temp!=nil)
            {
                [imageToZoom removeFromSuperview];
                imageToZoom=[[UIImageView alloc]initWithImage:temp];
                [imageToZoom setFrame:CGRectMake(0, 0, fullScreenMenuScrollView.frame.size.width, fullScreenMenuScrollView.frame.size.height)];
                [fullScreenMenuScrollView addSubview:imageToZoom];
                [fullScreenMenuScrollView setContentSize:self.view.frame.size];
                
            }
            
            [fullScreenMenuScrollView setUserInteractionEnabled:YES];
            [imageToZoom setContentMode: UIViewContentModeScaleAspectFit];
            [spinner stopAnimating];
        });
    });
    
    [fullScreenMenuImageView setAlpha:1.0f];
    [fullScreenMenuScrollView setAlpha:1.0f];
    
    [UIView commitAnimations];
}

-(void)showPopup:(UIButton *)sender
{
//    if (!isPopupShowed) {
//        [UIView beginAnimations:nil context:nil];
//        [UIView setAnimationDuration:0.3];
//        
//        [UIView setAnimationCurve:UIViewAnimationCurveEaseOut];
//        
//        [popupTop setAlpha:1.0];
//        [popupBottom setAlpha:1.0];
//        [distanceLabel setAlpha:1.0];
//        [line setAlpha:1.0];
//        [locationIcon setAlpha:1.0];
//        [restAddressLabel setAlpha:1.0];
//        [timeIcon setAlpha:1.0];
//        [restNameLabel setAlpha:1.0];
//        
//        [mapButton setAlpha:1.0];
//        //    [mapLabel setAlpha:1.0];
//        [sendButton setAlpha:1.0];
//        //    [sendLabel setAlpha:1.0];
//        [callButton setAlpha:1.0];
//        //    [callLabel setAlpha:1.0];
//        
//        [UIView commitAnimations];
//        int position;
//        if ([sender tag]>2000) {
//            position=2000;
//        }
//        else
//        {
//            position=1000;
//        }
//        Restaurant *temp=[restaurants objectAtIndex:(sender.tag-position)];
//        actualRestaurantIndex=sender.tag-position;
//        restNameLabel.text=temp.name;
//        restAddressLabel.text=temp.address;
//        
//        LocationManager*man=[LocationManager getInstance];
//        float a=[temp.lat floatValue];
//        float b=[temp.lng floatValue];
//        
//        if(man.la!=0 && man.lo!=0){
//            
//            float dist = [man calculateDistanceWithLatA:man.la
//                                                 andLoA:man.lo
//                                                andLatB:a
//                                                 andLoB:b];
//            if(dist >= 1000){
//                [distanceLabel setText: [NSString stringWithFormat: @"%0.2f km", dist/1000]];
//                if([self appdelegate].isFindNearby)
//                    cityLabel.text = [NSString stringWithFormat: @"%@ %.2f km",
//                                      NSLocalizedString(@"Distance", nil),
//                                      temp.distance/1000];
//            }
//            else{
//                [distanceLabel setText: [NSString stringWithFormat: @"%0.f m", dist]];
//                if([self appdelegate].isFindNearby)
//                    cityLabel.text = [NSString stringWithFormat: @"%@ %.f m",
//                                      NSLocalizedString(@"Distance", nil),
//                                      temp.distance];
//            }
//        }
//        else{
//            [distanceLabel setText: @""];
//        }
//        
//        isPopupShowed=YES;
//        
//    }
//    else
//    {
//        [self scrollViewDidScroll:nil];
//    }
//    
//    
    
    [self animateViewChange];
    ConnectionManager*connectionManager=[ConnectionManager getInstance];
    infoViewController.restaurants=[[NSMutableArray alloc]initWithArray:restaurants];
   
    infoViewController.index=sender.tag;
    [self.navigationController pushViewController:infoViewController animated:NO];
}
- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void) scrollViewDidScroll:(UIScrollView *)scrollView2
{
    isPopupShowed=NO;
    [UIView beginAnimations:nil context:nil];
    [UIView setAnimationDuration:0.3];
    
    [UIView setAnimationCurve:UIViewAnimationCurveEaseOut];
    
    [popupTop setAlpha:0.0];
    [popupBottom setAlpha:0.0];
    [distanceLabel setAlpha:0.0];
    [line setAlpha:0.0];
    [locationIcon setAlpha:0.0];
    [restAddressLabel setAlpha:0.0];
    [timeIcon setAlpha:0.0];
    [restNameLabel setAlpha:0.0];
    
    
    [mapButton setAlpha:0.0];
    
    [sendButton setAlpha:0.0];
    
    [callButton setAlpha:0.0];
    
    [UIView commitAnimations];
    
    
    if([self appdelegate].isFindNearby){
        for(int i=scrollView.subviews.count-1; i>0; i--){
            UIButton *vBtn = [scrollView.subviews objectAtIndex:i];
            
            int btnIndex = 0;
            if(vBtn.tag >= 2000)
                btnIndex = vBtn.tag-2000;
            else if(vBtn.tag >= 1000)
                btnIndex = vBtn.tag-1000;
            
            if(vBtn.frame.origin.y <= scrollView.contentOffset.y+100){
                
                Restaurant *rest=(Restaurant*)[restaurants objectAtIndex:btnIndex];
                LocationManager*man=[LocationManager getInstance];
                [man getLocation];
                rest.distance=[man calculateDistanceWithLatA:man.la
                                                      andLoA:man.lo
                                                     andLatB:[rest.lat floatValue]
                                                      andLoB:[rest.lng floatValue]];
                
                if(![cityLabel.text isEqualToString: [NSString stringWithFormat: @"%@ %.2f km", NSLocalizedString(@"Distance", nil), rest.distance]]
                   && ![cityLabel.text isEqualToString:[NSString stringWithFormat: @"%@ %.f m",NSLocalizedString(@"Distance", nil), rest.distance]]){
                    if(rest.distance >= 1000)
                        cityLabel.text = [NSString stringWithFormat: @"%@ %.2f km",NSLocalizedString(@"Distance", nil),rest.distance/1000];
                    else
                        cityLabel.text = [NSString stringWithFormat: @"%@ %.f m",NSLocalizedString(@"Distance", nil),rest.distance];
                    
                    NSLog(@"%f---- %f",scrollView.contentOffset.y, vBtn.frame.origin.y);
                    NSLog(@"name: %@ -- distance(m)=%f", rest.name, rest.distance);
                }
                break;
            }
        }
    }
}



- (void)viewDidUnload {
    [self setScrollView:nil];
    [self setTopBar:nil];
    [self setRightBar:nil];
    [self setLeftBar:nil];
    [self setCityLabel:nil];
    [self setPopupTop:nil];
    [self setPopupBottom:nil];
    [self setRestNameLabel:nil];
    [self setRestAddressLabel:nil];
    [self setLine:nil];
    [self setLocationIcon:nil];
    [self setTimeIcon:nil];
    [self setDistanceLabel:nil];
    [self setFullScreenMenuImageView:nil];
    [self setFullScreenMenuScrollView:nil];
    //    [self setSendLabel:nil];
    [self setSendButton:nil];
    //    [self setMapLabel:nil];
    [self setMapButton:nil];
    [self setCallButton:nil];
    
    [self setCallButton:nil];
    [self setMapButton:nil];
    
    [self setSendButton:nil];
    [self setSendButton:nil];
    [self setMapButton:nil];
    [self setCallButton:nil];
   
    [super viewDidUnload];
}

- (IBAction)goBack:(id)sender {
    
    //set actual index
    int position=0;
    for(UIView *subview in [self.scrollView subviews]) {
        int t=subview.frame.origin.y;
        
        if(t<self.scrollView.contentOffset.y+70+subview.frame.size.height/2)
        {
            if (subview.tag!=0) {
                position=subview.tag;
            }
        }
    }
    NSLog(@"%d",position);
    if (position>=2000) {
        position=position-2000;
    }
    if (position>=1000) {
        position=position-1000;
    }
    
    NSLog(@"currentRestaurantIndex = %d", position);
    [self appdelegate].currentIndex = position;
    
    
    [self animateViewChange];
    [self.navigationController popViewControllerAnimated:NO];

    ////
//    int position=0;
//    for(UIView *subview in [self.scrollView subviews]) {
//        int t=subview.frame.origin.y;
//        if(t<self.scrollView.contentOffset.y+70+subview.frame.size.height/2)
//        {
//            if (subview.tag!=0) {
//                position=subview.tag;
//            }
//        }
//    }
//    
//    
//    if (position>=2000) {
//        position=position-2000;
//    }
//    if (position>=1000) {
//        position=position-1000;
//    }
//    NSLog(@"position %d of %d",position, self.restaurants.count);
//    [self appdelegate].currentIndex = position;
//    
//    if(![self appdelegate].isFindNearby)
//        restaurantsHorizontalView.currentDistrictName = cityLabel.text;
//    else
//        restaurantsHorizontalView.currentDistrictName = NSLocalizedString(@"FindNearby", nil);
//        restaurantsHorizontalView.restaurants=self.restaurants;
//        restaurantsHorizontalView.currentRestaurantIndex=position;
//        [self animateViewChange];
//        [restaurantsHorizontalView setChangeDeviceOrientation:YES];
//        [[self navigationController] pushViewController: restaurantsHorizontalView animated:NO];
}

- (IBAction)goToDistrictView:(id)sender {
    [self animateViewChange];
    
    
    [self.navigationController popToViewController:[self.navigationController.viewControllers objectAtIndex:1] animated:NO];

    
}
- (IBAction)send:(id)sender {
    
    
    
  
        NSString *actionSheetTitle = @""; //Action Sheet Title
        NSString *other1 = @"";
        NSString *other2 = @"";
        NSString *other3 = @"";
        NSString *other4 = @"";
        NSString *cancelTitle = @"Cancel";
        UIActionSheet *actionSheet = [[UIActionSheet alloc]
                                      initWithTitle:actionSheetTitle
                                      delegate:self
                                      cancelButtonTitle:cancelTitle
                                      destructiveButtonTitle:nil
                                      otherButtonTitles:other1, other2, other3,other4, nil];
        actionSheet.actionSheetStyle=UIActionSheetStyleBlackOpaque;
        [actionSheet showInView:self.view];
        actionSheet.alpha=0.9;// setAlpha:0.8];
        
        
        UIButton*temp=[[actionSheet subviews]objectAtIndex:1];
        [temp setBackgroundImage:[UIImage imageNamed:@"email.png"] forState:UIControlStateNormal];
        [temp setBackgroundImage:[UIImage imageNamed:@"email2.png"] forState:UIControlStateHighlighted];
        [temp setBounds:CGRectMake(0, 0, 65, 65)];
        [temp setBackgroundColor:[UIColor blackColor]];
        [temp setCenter:CGPointMake(60, 66)];
        [temp setBackgroundColor:[UIColor clearColor]];
        UIFont* font=[UIFont fontWithName:@"Helvetica-Bold" size:12.0];
        UILabel*title=[[UILabel alloc]initWithFrame:CGRectMake(0, 68, 65, 12)];
        [title setTextAlignment:NSTextAlignmentCenter];
        title.font=font;
        title.text=@"Mail";
        title.backgroundColor=[UIColor clearColor];
        title.textColor=[UIColor whiteColor];
        [temp addSubview:title];
        
        
        UIButton*temp2=[[actionSheet subviews]objectAtIndex:2];
        [temp2 setBackgroundImage:[UIImage imageNamed:@"message.png"] forState:UIControlStateNormal];
        [temp2 setBackgroundImage:[UIImage imageNamed:@"message2.png"] forState:UIControlStateHighlighted];
        [temp2 setBounds:CGRectMake(0, 0, 60, 60)];
        [temp2 setBackgroundColor:[UIColor blackColor]];
        [temp2 setCenter:CGPointMake(self.view.frame.size.width/2, 65)];
        [temp2 setBackgroundColor:[UIColor clearColor]];
        UILabel*title2=[[UILabel alloc]initWithFrame:CGRectMake(0, 65, 60, 12)];
        [title2 setTextAlignment:NSTextAlignmentCenter];
        title2.font=font;
        title2.text=@"Message";
        title2.backgroundColor=[UIColor clearColor];
        title2.textColor=[UIColor whiteColor];
        [temp2 addSubview:title2];
        
        UIButton*temp3=[[actionSheet subviews]objectAtIndex:3];
        [temp3 setBackgroundImage:[UIImage imageNamed:@"twitter.png"] forState:UIControlStateNormal];
        [temp3 setBackgroundImage:[UIImage imageNamed:@"twitter2.png"] forState:UIControlStateHighlighted];
        [temp3 setBounds:CGRectMake(0, 0, 60, 60)];
        [temp3 setBackgroundColor:[UIColor blackColor]];
        [temp3 setCenter:CGPointMake(260, 65)];
        [temp3 setBackgroundColor:[UIColor clearColor]];
        UILabel*title3=[[UILabel alloc]initWithFrame:CGRectMake(0, 65, 60, 12)];
        [title3 setTextAlignment:NSTextAlignmentCenter];
        title3.font=font;
        title3.text=@"Twitter";
        title3.backgroundColor=[UIColor clearColor];
        title3.textColor=[UIColor whiteColor];
        [temp3 addSubview:title3];
        
        UIButton*temp4=[[actionSheet subviews]objectAtIndex:4];
        [temp4 setBackgroundImage:[UIImage imageNamed:@"facebook.png"] forState:UIControlStateNormal];
        [temp4 setBackgroundImage:[UIImage imageNamed:@"facebook2.png"] forState:UIControlStateHighlighted];
        [temp4 setBounds:CGRectMake(0, 0, 60, 60)];
        [temp4 setBackgroundColor:[UIColor blackColor]];
        [temp4 setCenter:CGPointMake(60, 180)];
        [temp4 setBackgroundColor:[UIColor clearColor]];
        UILabel*title4=[[UILabel alloc]initWithFrame:CGRectMake(0, 65, 60, 12)];
        [title4 setTextAlignment:NSTextAlignmentCenter];
        title4.font=font;
        title4.text=@"Facebook";
        title4.backgroundColor=[UIColor clearColor];
        title4.textColor=[UIColor whiteColor];
        [temp4 addSubview:title4];
        
        
        
    
}



- (void)actionSheet:(UIActionSheet *)actionSheet clickedButtonAtIndex:(NSInteger)buttonIndex {
    if(buttonIndex==0)
    {
        if ([MFMailComposeViewController canSendMail])
        {
            Restaurant *temp=[restaurants objectAtIndex:actualRestaurantIndex];
            NSString* someText = [NSString stringWithFormat:@"%@ %@", NSLocalizedString(@"MAILBODY", nil),temp.address];
            //        NSString* someText = [NSString stringWithFormat:@"%@ %@", @"Come to restaurant at",temp.address];
            
            MFMailComposeViewController *mailer = [[MFMailComposeViewController alloc] init];
            mailer.mailComposeDelegate = self;
            [mailer setSubject:NSLocalizedString(@"MailSubject", nil)];
            
            UIImage *myImage = temp.downloadedMainImage;
            NSData *imageData = UIImagePNGRepresentation(myImage);
            [mailer addAttachmentData:imageData mimeType:@"image/png" fileName:@"main"];
            
            UIImage *myImage2 = temp.downloadedMenuImage;
            NSData *imageData2 = UIImagePNGRepresentation(myImage2);
            [mailer addAttachmentData:imageData2 mimeType:@"image/png" fileName:@"menu"];
            
            
            NSString *emailBody = someText;
            [mailer setMessageBody:emailBody isHTML:NO];
            [self presentModalViewController:mailer animated:YES];
        }
        else
        {
            UIAlertView *alert = [[UIAlertView alloc] initWithTitle:NSLocalizedString(@"Failure", nil)
                                                            message:NSLocalizedString(@"M ComposerNotSupported", nil)
                                                           delegate:nil
                                                  cancelButtonTitle:NSLocalizedString(@"OkButton", nil)
                                                  otherButtonTitles:nil];;
            
            [alert show];
            
        }
    }
    else if (buttonIndex==1)
    {
        MFMessageComposeViewController *controller = [[MFMessageComposeViewController alloc] init];
        if([MFMessageComposeViewController canSendText])
        {
            Restaurant* showedRestaurant=[restaurants objectAtIndex:actualRestaurantIndex];
            NSString* someText = showedRestaurant.name;
            controller.body =someText;
            controller.recipients = [NSArray arrayWithObjects:@"", nil];
            controller.messageComposeDelegate = self;
            controller.delegate = self;
            [self presentModalViewController:controller animated:YES];
        }
    }
    else if (buttonIndex==2)
    {
        [self sendEasyTweet:nil];
    }
    else if (buttonIndex==3)
    {
        
        
        [self openSession];
    }
}

- (IBAction)sendEasyTweet:(id)sender {
    // Set up the built-in twitter composition view controller.
    TWTweetComposeViewController *tweetViewController = [[TWTweetComposeViewController alloc] init];
    Restaurant*t=[restaurants objectAtIndex:actualRestaurantIndex];
    // Set the initial tweet text. See the framework for additional properties that can be set.
    NSString * content=[NSString stringWithFormat:@"Come here. It's a great restaurant! %@  at %@",t.name,t.address];
    [tweetViewController setInitialText:content];
    [tweetViewController addImage:t.downloadedMainImage];
    [tweetViewController addImage:t.downloadedMenuImage];
    // Create the completion handler block.
    [tweetViewController setCompletionHandler:^(TWTweetComposeViewControllerResult result) {
        NSString *output;
        
        switch (result) {
            case TWTweetComposeViewControllerResultCancelled:
                // The cancel button was tapped.
                output = @"Tweet cancelled.";
                break;
            case TWTweetComposeViewControllerResultDone:
                // The tweet was sent.
                output = @"Tweet done.";
                break;
            default:
                break;
        }
        
        // [self performSelectorOnMainThread:@selector(displayText:) withObject:output waitUntilDone:NO];
        
        // Dismiss the tweet composition view controller.
        [self dismissModalViewControllerAnimated:YES];
    }];
    
    // Present the tweet composition view controller modally.
    [self presentModalViewController:tweetViewController animated:YES];
}


- (void) performPublishAction:(void (^)(void)) action {
    NSLog(@"wywolano");
    // we defer request for permission to post to the moment of post, then we check for the permission
    if ([FBSession.activeSession.permissions indexOfObject:@"publish_actions"] == NSNotFound) {
        // if we don't already have the permission, then we request it now
        [FBSession.activeSession requestNewPublishPermissions:@[@"publish_actions"]
                                              defaultAudience:FBSessionDefaultAudienceFriends
                                            completionHandler:^(FBSession *session, NSError *error) {
                                                if (!error) {
                                                    action();
                                                }
                                                //For this example, ignore errors (such as if user cancels).
                                            }];
    } else {
        action();    }
    
}

- (IBAction)postPhotoClick:(UIButton *)sender {
    // Just use the icon image from the application itself.  A real app would have a more
    // useful way to get an image.
    UIImage *img = [[restaurants objectAtIndex:actualRestaurantIndex] downloadedMenuImage];
    
    // if it is available to us, we will post using the native dialog
    //    BOOL displayedNativeDialog = [FBNativeDialogs presentShareDialogModallyFrom:self
    //                                                                    initialText:nil
    //                                                                          image:img
    //                                                                            url:nil
    //                                                                        handler:nil];
    //    if (!displayedNativeDialog) {
    
    
    [self performPublishAction:^{
        
        [FBRequestConnection startForUploadPhoto:img
                               completionHandler:^(FBRequestConnection *connection, id result, NSError *error) {
                                   
                                   [self postStatusUpdateClick:nil];
                               }];
        
    }];
    
}
//}

- (IBAction)postStatusUpdateClick:(UIButton *)sender {
    // Post a status update to the user's feed via the Graph API, and display an alert view
    // with the results or an error.
    
    // if it is available to us, we will post using the native dialog
    BOOL displayedNativeDialog = [FBNativeDialogs presentShareDialogModallyFrom:self
                                                                    initialText:nil
                                                                          image:nil
                                                                            url:nil
                                                                        handler:nil];
    if (!displayedNativeDialog) {
        Restaurant*t=[restaurants objectAtIndex:actualRestaurantIndex];
        [self performPublishAction:^{
            // otherwise fall back on a request for permissions and a direct post
            NSString *message = [NSString stringWithFormat:@"Come to restaurant %@ at %@",t.name, t.address];
            
            [FBRequestConnection startForPostStatusUpdate:message
                                        completionHandler:^(FBRequestConnection *connection, id result, NSError *error) {
                                            
                                            UIAlertView*alert=[[UIAlertView alloc]initWithTitle:NSLocalizedString(@"Success", nil) message:NSLocalizedString(@"Post Uploaded", nil) delegate:nil cancelButtonTitle:@"OkButton" otherButtonTitles:nil, nil];
                                            [alert show];
                                            
                                        }];
            
            
        }];
    }
}
- (void)sessionStateChanged:(FBSession *)session
                      state:(FBSessionState) state
                      error:(NSError *)error
{
    switch (state) {
        case FBSessionStateOpen: {
            NSLog(@"poszlo ok");
            [self postPhotoClick:nil];
            
        }
            break;
        case FBSessionStateClosed:
        case FBSessionStateClosedLoginFailed:
        {
            NSLog(@"poszlo zle");
        }
            
            [FBSession.activeSession closeAndClearTokenInformation];
            
            
            break;
        default:
            break;
    }
    
    if (error) {
        UIAlertView *alertView = [[UIAlertView alloc]
                                  initWithTitle:NSLocalizedString(@"Error", nil)
                                  message:error.localizedDescription
                                  delegate:nil
                                  cancelButtonTitle:NSLocalizedString(@"OkButton", nil)
                                  otherButtonTitles:nil];
        [alertView show];
    }
}
- (BOOL)application:(UIApplication *)application
            openURL:(NSURL *)url
  sourceApplication:(NSString *)sourceApplication
         annotation:(id)annotation
{
    return [FBSession.activeSession handleOpenURL:url];
}

- (void)openSession
{
    [FBSession openActiveSessionWithReadPermissions:nil
                                       allowLoginUI:YES
                                  completionHandler:
     ^(FBSession *session,
       FBSessionState state, NSError *error) {
         [self sessionStateChanged:session state:state error:error];
     }];
}
- (void)mailComposeController:(MFMailComposeViewController*)controller didFinishWithResult:(MFMailComposeResult)result error:(NSError*)error
{
    switch (result)
    {
        case MFMailComposeResultCancelled:
            NSLog(@"Mail cancelled: you cancelled the operation and no email message was queued.");
            break;
        case MFMailComposeResultSaved:
            NSLog(@"Mail saved: you saved the email message in the drafts folder.");
            break;
        case MFMailComposeResultSent:
            NSLog(@"Mail send: the email message is queued in the outbox. It is ready to send.");
            break;
        case MFMailComposeResultFailed:
            NSLog(@"Mail failed: the email message was not saved or queued, possibly due to an error.");
            break;
        default:
            NSLog(@"Mail not sent.");
            break;
    }
    // Remove the mail view
    [self dismissModalViewControllerAnimated:YES];
}

- (IBAction)goToMap:(id)sender {
    mapController=[self.storyboard instantiateViewControllerWithIdentifier:@"map" ];
    Restaurant* temp=[restaurants objectAtIndex:actualRestaurantIndex];
    mapController.restaurant=temp;
    mapController.distance=self.distanceLabel.text;
    [self animateViewChange];
    [self.navigationController pushViewController:mapController animated:NO];
    
}


-(BOOL)shouldAutorotate{
    UIInterfaceOrientation interfaceOrientation = [[UIDevice currentDevice] orientation];
    return interfaceOrientation==UIInterfaceOrientationLandscapeLeft || interfaceOrientation==UIInterfaceOrientationLandscapeRight;
}

- (NSUInteger)supportedInterfaceOrientations{
    if ([self isPad]) {
        return UIInterfaceOrientationMaskPortrait;
    }
    else
    return UIInterfaceOrientationMaskAll;
}

- (void)willAnimateRotationToInterfaceOrientation:(UIInterfaceOrientation)  interfaceOrientation duration:(NSTimeInterval)duration
{
    [self shouldAutorotateToInterfaceOrientation:[[UIDevice currentDevice] orientation]];
    
}


- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    if(interfaceOrientation==UIInterfaceOrientationLandscapeLeft || interfaceOrientation==UIInterfaceOrientationLandscapeRight)
    {
        if ([self isPad]) {
            ;
        }
        else
        {
            
        
        if(![[[self navigationController]topViewController] isEqual:restaurantsHorizontalView]){
            int position=0;
            for(UIView *subview in [self.scrollView subviews]) {
                int t=subview.frame.origin.y;
                
                if(t<self.scrollView.contentOffset.y+70+subview.frame.size.height/2)
                {
                    if (subview.tag!=0) {
                        position=subview.tag;
                    }
                }
            }
            NSLog(@"%d",position);
            if (position>=2000) {
                position=position-2000;
            }
            if (position>=1000) {
                position=position-1000;
            }
            
            NSLog(@"currentRestaurantIndex = %d", position);
            [self appdelegate].currentIndex = position;
            if(![self appdelegate].isFindNearby)
                restaurantsHorizontalView.currentDistrictName = cityLabel.text;
            else
                restaurantsHorizontalView.currentDistrictName = NSLocalizedString(@"FindNearby", nil);
            restaurantsHorizontalView.restaurants=self.restaurants;
            restaurantsHorizontalView.currentRestaurantIndex=position;
            [self animateViewChange];
            [[self navigationController] pushViewController: restaurantsHorizontalView animated:NO];
            
        }
        }
    }
    return YES;
}
- (IBAction)call:(id)sender {
    
    NSLog(@"%@",[[restaurants objectAtIndex:actualRestaurantIndex] name]);
    
    UIDevice *device = [UIDevice currentDevice];
    
    if ([[device model] isEqualToString:@"iPhone"] ) {
        
        if (![[[restaurants objectAtIndex:actualRestaurantIndex] phoneRestaurant]isEqualToString:@""]) {
            
            NSString *str = [[restaurants objectAtIndex:actualRestaurantIndex] phoneRestaurant];
            
            
            
            str = [str stringByReplacingOccurrencesOfString:@" "
                   
                                                 withString:@""];
            
            
            
            str = [str stringByReplacingOccurrencesOfString:@"-"
                   
                                                 withString:@""];
            
            
            
            str = [str stringByReplacingOccurrencesOfString:@"."
                   
                                                 withString:@""];
            
            
            
            str = [str stringByReplacingOccurrencesOfString:@":"
                   
                                                 withString:@""];
            
            
            
            
            
            NSString *phoneNumber = [@"telprompt://" stringByAppendingString:str];
            
            [[UIApplication sharedApplication] openURL:[NSURL URLWithString:phoneNumber]];
            
            
            
            
            
        }
        
        else
            
        {
            
            UIAlertView *Notpermitted=[[UIAlertView alloc] initWithTitle:@""
                                       
                                                                 message: NSLocalizedString(@"NoNumber", nil)
                                       
                                                                delegate:nil
                                       
                                                       cancelButtonTitle:NSLocalizedString(@"OkButton", nil)
                                       
                                                       otherButtonTitles:nil];
            
            [Notpermitted show];
            
        }
        
        
        
    } else {
        
        UIAlertView *Notpermitted=[[UIAlertView alloc] initWithTitle:@""
                                   
                                                             message:NSLocalizedString(@"NotSupportedFeature", nil)
                                   
                                                            delegate:nil
                                   
                                                   cancelButtonTitle:NSLocalizedString(@"OkButton", nil)
                                   
                                                   otherButtonTitles:nil];
        
        [Notpermitted show];
        
        
        
    }
    
}

- (void)willRotateToInterfaceOrientation:(UIInterfaceOrientation)toInterfaceOrientation duration:(NSTimeInterval)duration
{
//    [UIView setAnimationsEnabled:NO]; // disable animations temporarily
}

- (void)didRotateFromInterfaceOrientation:(UIInterfaceOrientation)fromInterfaceOrientation
{
//    [UIView setAnimationsEnabled:YES]; // rotation finished, re-enable them
}



- (IBAction)changeOrientation:(id)sender {
//    int position=0;
//    for(UIView *subview in [self.scrollView subviews]) {
//        int t=subview.frame.origin.y;
//        if(t<self.scrollView.contentOffset.y+70+subview.frame.size.height/2)
//        {
//            if (subview.tag!=0) {
//                position=subview.tag;
//            }
//        }
//    }
//    
//    
//    if (position>=2000) {
//        position=position-2000;
//    }
//   else if (position>=1000) {
//        position=position-1000;
//    }
//    NSLog(@"position %d of %d",position, self.restaurants.count);
//    [self appdelegate].currentIndex = position;
//    
//    if(![self appdelegate].isFindNearby)
//        restaurantsHorizontalView.currentDistrictName = cityLabel.text;
//    else
//        restaurantsHorizontalView.currentDistrictName = NSLocalizedString(@"FindNearby", nil);
//    restaurantsHorizontalView.restaurants=self.restaurants;
//    restaurantsHorizontalView.currentRestaurantIndex=position;
//    [self animateViewChange];
//    [restaurantsHorizontalView setChangeDeviceOrientation:YES];
//    [[self navigationController] pushViewController: restaurantsHorizontalView animated:NO];

}

-(void)animateViewChange{
    CATransition* transition = [CATransition animation];
    transition.duration = 0.4;
    transition.type = kCATransitionFade;
    transition.subtype = kCATransitionFromTop;
    [self.navigationController.view.layer
     addAnimation:transition forKey:kCATransition];
}

- (AppDelegate *) appdelegate {
    return (AppDelegate *)[[UIApplication sharedApplication] delegate];
}
@end
