//
//  iBillboard.m
//  iBillboardClasses
//
//  Created by Pawel Ferens on 4/15/13.
//  Copyright (c) 2013 Pawel Ferens. All rights reserved.
//

#import "AdView.h"
#import <AVFoundation/AVFoundation.h>
@interface AdView ()
@property (nonatomic,retain) ExpandProperties * expandProperties;
@property (nonatomic,retain) NSString * placementType;
@property (nonatomic, retain) NSString * stateType;
@property bool isDefaultPositionSet;
@property int setFrameCounter;
@property (nonatomic) CGRect defaultPosition;
@property (nonatomic , retain) AVPlayer * player;
@property  AVPlayerLayer * layerr;
@property bool isViewable;
@property UIButton * closeButton;
@property ResizeProperties * resizeProperties;
@property CGRect  screenSize;
@property UIInterfaceOrientation  orientation;
@end


@implementation AdView

@synthesize jsBridge;
@synthesize expandProperties;
@synthesize placementType;
@synthesize stateType;
@synthesize isDefaultPositionSet;
@synthesize setFrameCounter;
@synthesize defaultPosition;
@synthesize player;
@synthesize layerr;
@synthesize isViewable;
@synthesize closeButton;
@synthesize resizeProperties;
@synthesize screenSize;
@synthesize orientation;
UIView * view;


-(id) initWithView:(UIView*)actualView andPlacementType:(NSString*)placementType
   
{
    self = [super init];
    if(self)
    {
        screenSize=[[UIScreen mainScreen]bounds];
        orientation = [[UIApplication sharedApplication]statusBarOrientation];
        jsBridge = [TGJSBridge jsBridgeWithDelegate:self];
        [self setDelegate:jsBridge];
        [self setAlpha:0.0];
        isDefaultPositionSet=NO;
        setFrameCounter=0;
        view=actualView;
        self.placementType=placementType;
        stateType=@"loading";
        [self setStateType:@"loading"];
        
       NSURL* url = [[NSBundle mainBundle] URLForResource:@"test" withExtension:@"html"];
        [self loadRequest:[NSURLRequest requestWithURL:url]];
        
        // setting properties to js object
        [self setVersion];
        [self setScreenSize];
        [self setPlacementType];
        [self setStateType];
        [self setMaxSize];
        
        self.allowsInlineMediaPlayback=YES;
        self.mediaPlaybackRequiresUserAction=NO;

        [[UIDevice currentDevice] beginGeneratingDeviceOrientationNotifications];
        [[NSNotificationCenter defaultCenter]
         addObserver:self selector:@selector(orientationChanged:)
         name:UIDeviceOrientationDidChangeNotification
         object:[UIDevice currentDevice]];
        
      
    }
    
    return self;
}


- (void) orientationChanged:(NSNotification *)note
{
    NSLog(@"%f",view.frame.size.width);
    CGRect screenRect = [[UIScreen mainScreen] bounds];
    CGFloat screenWidth = screenRect.size.width;
    CGFloat screenHeight = screenRect.size.height;
    
    
    UIDevice * device = note.object;
    switch(device.orientation)
    {
        case UIDeviceOrientationPortrait:
            if (UIDeviceOrientationIsPortrait(orientation)) {
                ;
            }
            else
            {
                orientation=UIDeviceOrientationPortrait;
            screenSize.size.width=screenWidth;
            screenSize.size.height=screenHeight;
            
            [self.jsBridge postNotificationName:@"setScreenWidth" userInfo:[NSDictionary dictionaryWithObjectsAndKeys:[NSString stringWithFormat:@"%f",screenHeight],@"message", nil] toWebView:self];
            
            [self.jsBridge postNotificationName:@"setScreenHeight" userInfo:[NSDictionary dictionaryWithObjectsAndKeys:[NSString stringWithFormat:@"%f",screenWidth],@"message", nil] toWebView:self];
            NSLog(@"pion");
            }
            break;
            
        case UIDeviceOrientationPortraitUpsideDown:
            NSLog(@"upsidedown");
            if (UIDeviceOrientationIsPortrait(orientation)) {
                ;
            }
            else
            {
            orientation=UIDeviceOrientationPortraitUpsideDown;
            screenSize.size.width=screenWidth;
            screenSize.size.height=screenHeight;
            
            [self.jsBridge postNotificationName:@"setScreenWidth" userInfo:[NSDictionary dictionaryWithObjectsAndKeys:[NSString stringWithFormat:@"%f",screenHeight],@"message", nil] toWebView:self];
            
            [self.jsBridge postNotificationName:@"setScreenHeight" userInfo:[NSDictionary dictionaryWithObjectsAndKeys:[NSString stringWithFormat:@"%f",screenWidth],@"message", nil] toWebView:self];
            }
            break;
            
        case UIDeviceOrientationLandscapeLeft:
              NSLog(@"poziomy");
            if (UIDeviceOrientationIsLandscape(orientation)) {
                ;
            }
            else
            {
                orientation=UIDeviceOrientationLandscapeLeft;
                screenSize.size.width=screenHeight;
                screenSize.size.height=screenWidth;
                
                [self.jsBridge postNotificationName:@"setScreenWidth" userInfo:[NSDictionary dictionaryWithObjectsAndKeys:[NSString stringWithFormat:@"%f",screenHeight],@"message", nil] toWebView:self];
                
                [self.jsBridge postNotificationName:@"setScreenHeight" userInfo:[NSDictionary dictionaryWithObjectsAndKeys:[NSString stringWithFormat:@"%f",screenWidth],@"message", nil] toWebView:self];
                
                
            }
            
        case UIDeviceOrientationLandscapeRight:
            if (UIDeviceOrientationIsLandscape(orientation)) {
                ;
            }
            else
            {
                orientation=UIDeviceOrientationLandscapeRight;
                NSLog(@"poziomy");
                CGRect screenRect = [[UIScreen mainScreen] bounds];
                CGFloat screenWidth = screenRect.size.width;
                CGFloat screenHeight = screenRect.size.height;
                
                screenSize.size.width=screenHeight;
                screenSize.size.height=screenWidth;
                
                [self.jsBridge postNotificationName:@"setScreenWidth" userInfo:[NSDictionary dictionaryWithObjectsAndKeys:[NSString stringWithFormat:@"%f",screenHeight],@"message", nil] toWebView:self];
                
                [self.jsBridge postNotificationName:@"setScreenHeight" userInfo:[NSDictionary dictionaryWithObjectsAndKeys:[NSString stringWithFormat:@"%f",screenWidth],@"message", nil] toWebView:self];
                
                
            }

            
            default:
            break;
    };
        
    
}

- (void) setFrame:(CGRect)frame
{
    
    [super setFrame:frame];
    setFrameCounter++;
    NSLog(@"zmiana frame %f  %f",frame.origin.x,frame.origin.y);
    if (isDefaultPositionSet) {
        [self.jsBridge postNotificationName:@"setCurrentPositionX" userInfo:[NSDictionary dictionaryWithObjectsAndKeys:[NSString stringWithFormat:@"%f",frame.origin.x],@"message", nil] toWebView:self];
        
        [self.jsBridge postNotificationName:@"setCurrentPositionY" userInfo:[NSDictionary dictionaryWithObjectsAndKeys:[NSString stringWithFormat:@"%f",frame.origin.y],@"message", nil] toWebView:self];
        
        [self.jsBridge postNotificationName:@"setCurrentPositionWidth" userInfo:[NSDictionary dictionaryWithObjectsAndKeys:[NSString stringWithFormat:@"%f",frame.size.width],@"message", nil] toWebView:self];
        
        [self.jsBridge postNotificationName:@"setCurrentPositionHeigth" userInfo:[NSDictionary dictionaryWithObjectsAndKeys:[NSString stringWithFormat:@"%f",frame.size.height],@"message", nil] toWebView:self];
    }
    else
    {
        if (setFrameCounter==1) {
            
            defaultPosition= CGRectMake(frame.origin.x, frame.origin.y, frame.size.width, frame.size.height);
            
            [self.jsBridge postNotificationName:@"setDefaultPositionX" userInfo:[NSDictionary dictionaryWithObjectsAndKeys:[NSString stringWithFormat:@"%f",frame.origin.x],@"message", nil] toWebView:self];
            
            [self.jsBridge postNotificationName:@"setDefaultPositionY" userInfo:[NSDictionary dictionaryWithObjectsAndKeys:[NSString stringWithFormat:@"%f",frame.origin.y],@"message", nil] toWebView:self];
            
            [self.jsBridge postNotificationName:@"setDefaultPositionWidth" userInfo:[NSDictionary dictionaryWithObjectsAndKeys:[NSString stringWithFormat:@"%f",frame.size.width],@"message", nil] toWebView:self];
            
            [self.jsBridge postNotificationName:@"setDefaultPositionHeigth" userInfo:[NSDictionary dictionaryWithObjectsAndKeys:[NSString stringWithFormat:@"%f",frame.size.height],@"message", nil] toWebView:self];
            
            
            [self.jsBridge postNotificationName:@"setCurrentPositionX" userInfo:[NSDictionary dictionaryWithObjectsAndKeys:[NSString stringWithFormat:@"%f",frame.origin.x],@"message", nil] toWebView:self];
            
            [self.jsBridge postNotificationName:@"setCurrentPositionY" userInfo:[NSDictionary dictionaryWithObjectsAndKeys:[NSString stringWithFormat:@"%f",frame.origin.y],@"message", nil] toWebView:self];
            
            [self.jsBridge postNotificationName:@"setCurrentPositionWidth" userInfo:[NSDictionary dictionaryWithObjectsAndKeys:[NSString stringWithFormat:@"%f",frame.size.width],@"message", nil] toWebView:self];
            
            [self.jsBridge postNotificationName:@"setCurrentPositionHeigth" userInfo:[NSDictionary dictionaryWithObjectsAndKeys:[NSString stringWithFormat:@"%f",frame.size.height],@"message", nil] toWebView:self];
            
            isDefaultPositionSet=YES;
        }
        else
        {
            [self.jsBridge postNotificationName:@"setCurrentPositionX" userInfo:[NSDictionary dictionaryWithObjectsAndKeys:[NSString stringWithFormat:@"%f",frame.origin.x],@"message", nil] toWebView:self];
            
            [self.jsBridge postNotificationName:@"setCurrentPositionY" userInfo:[NSDictionary dictionaryWithObjectsAndKeys:[NSString stringWithFormat:@"%f",frame.origin.y],@"message", nil] toWebView:self];
            
            [self.jsBridge postNotificationName:@"setCurrentPositionWidth" userInfo:[NSDictionary dictionaryWithObjectsAndKeys:[NSString stringWithFormat:@"%f",frame.size.width],@"message", nil] toWebView:self];
            
            [self.jsBridge postNotificationName:@"setCurrentPositionHeigth" userInfo:[NSDictionary dictionaryWithObjectsAndKeys:[NSString stringWithFormat:@"%f",frame.size.height],@"message", nil] toWebView:self];
        }
    }
    
   
}

- (void)webViewDidFinishLoad:(UIWebView *)webView
{
    stateType=@"default";
    [self setStateType];
    [self setAlpha:1.0];
  
}
-(NSString *)getDeviceInfo
{
    NSString * stringWithInfo;
    stringWithInfo=[[NSString alloc]init];
    
    UIDevice * currentDevice = [UIDevice currentDevice];
    NSString * model = [currentDevice model];
    
    NSString * systemVersion = [currentDevice systemVersion];
    NSArray * languageArray = [NSLocale preferredLanguages];
    NSString * language = [languageArray objectAtIndex:0];
    NSLocale * locale = [NSLocale currentLocale];
    NSString * country = [locale localeIdentifier];
    NSString * screenHeigth=[NSString stringWithFormat:@"%f",view.frame.size.height];
    NSString * screenWidth=[NSString stringWithFormat:@"%f",view.frame.size.width];
    NSString * orientation=[self stringFromOrientation:[[UIApplication sharedApplication] statusBarOrientation]];
    stringWithInfo=[NSString stringWithFormat:@"%@,%@,%@,%@,%@,%@,%@,%@,",currentDevice,model,systemVersion,language,country,screenHeigth,screenWidth,orientation];
    NSLog(@"%@",stringWithInfo);
    return stringWithInfo;
}

- (NSString *)stringFromOrientation:(UIDeviceOrientation) orientation {
    
    NSString *orientationString;
    switch (orientation) {
        case UIDeviceOrientationPortrait:
            orientationString =  @"Portrait";
            break;
        case UIDeviceOrientationPortraitUpsideDown:
            orientationString =  @"Portrait";
            break;
        case UIDeviceOrientationLandscapeLeft:
            orientationString =  @"Landscape";
            break;
        case UIDeviceOrientationLandscapeRight:
            orientationString =  @"Landscape";
            break;
        case UIDeviceOrientationFaceUp:
            orientationString =  @"Face Up";
            break;
        case UIDeviceOrientationFaceDown:
            orientationString =  @"Face Down";
            break;
        case UIDeviceOrientationUnknown:
            orientationString = @"Unknown";
            break;
        default:
            orientationString = @"Unknown";
            break;
    }
    return orientationString;
}


- (void)jsBridge:(TGJSBridge *)bridge didReceivedNotificationName:(NSString *)name userInfo:(NSDictionary *)userInfo fromWebView:(UIWebView *)webview
{
    if ([name isEqualToString:@"close"]) {
        [self close];
    }
    else if ([name isEqualToString:@"expand"]) {
        [self expand];
    }
   else if ([name isEqualToString:@"resize"]) {
      
       [self resize];
    }
    else if ([name isEqualToString:@"open"])
    {
        NSURL *url = [NSURL URLWithString:[userInfo objectForKey:@"message"]];
        [[UIApplication sharedApplication] openURL:url];
       
    }
    
    else if ([name isEqualToString:@"playVideo"])
    {
        NSURL *url = [NSURL URLWithString:[userInfo objectForKey:@"message"]];
         [[UIApplication sharedApplication] openURL:url];
    }
    
    else if ([name isEqualToString:@"storePicture"])
    {
        [self storePictureWithString:[userInfo objectForKey:@"message"]];
    }
    
    else if ([name isEqualToString:@"createCalendarEvent"])
    {
        EKEventStore * eventStore=[[EKEventStore alloc] init];
        EKEvent *addEvent=[EKEvent eventWithEventStore:eventStore];
        addEvent.title=@"dodano nowy event z iBillboard";
        addEvent.startDate=[NSDate date];
        addEvent.endDate=[addEvent.startDate dateByAddingTimeInterval:600];
        [addEvent setCalendar:[eventStore defaultCalendarForNewEvents]];
        addEvent.alarms=[NSArray arrayWithObject:[EKAlarm alarmWithAbsoluteDate:addEvent.startDate]];
        [eventStore saveEvent:addEvent span:EKSpanThisEvent error:nil];
    }
    
    else if ([name isEqualToString:@"setExpandProperties"])
    {
        if ([stateType isEqualToString:@"default"] || [stateType isEqualToString:@"resized"]) {
            
            NSDictionary *dict = [userInfo objectForKey:@"message"];
            ExpandProperties*properties=[[ExpandProperties alloc]init];
            [properties setHeight:[[dict objectForKey:@"height"]intValue]];
            [properties setWidth:[[dict objectForKey:@"width"]intValue]];
            [properties setIsModal:[[dict objectForKey:@"isModal"]boolValue]];
            [properties setUseCustomClose:[[dict objectForKey:@"useCustomClose"]boolValue]];
            [self setExpandProperties:properties ];
        }
        
        
       
    }
    else if ([name isEqualToString:@"setResizeProperties"])
    {
        NSDictionary *dict = [userInfo objectForKey:@"message"];
        
        ResizeProperties*properties=[[ResizeProperties alloc]init];
        [properties setHeight:[[dict objectForKey:@"height"]intValue]];
        [properties setWidth:[[dict objectForKey:@"width"]intValue]];
        [properties setOffsetX:[[dict objectForKey:@"offsetX"]intValue]];
        [properties setOffsetY:[[dict objectForKey:@"offsetY"]intValue]];
        [properties setAllowOfScreen:[[dict objectForKey:@"allowOfscreen"]boolValue]];
        [properties setCustomClosePosition:[dict objectForKey:@"customClosePosition"]];
        [self setResizeProperties:properties];
        NSLog(@" %@",resizeProperties.customClosePosition);
        
        
    }

   }

- (void)playerItemDidReachEnd:(NSNotification *)notification {//works only with avplayer
    [layerr removeFromSuperlayer ];
    NSLog(@"koniec");
}

-(void)setVersion
{
    [self.jsBridge postNotificationName:@"setVersion" userInfo:[NSDictionary dictionaryWithObjectsAndKeys:@"2.0",@"message", nil] toWebView:self];
    
    
}
-(void)setScreenSize
{
    CGRect screenRect = [[UIScreen mainScreen] bounds];
    CGFloat screenWidth = screenRect.size.width;
    CGFloat screenHeight = screenRect.size.height;
    
    [self.jsBridge postNotificationName:@"setScreenWidth" userInfo:[NSDictionary dictionaryWithObjectsAndKeys:[NSString stringWithFormat:@"%f",screenWidth],@"message", nil] toWebView:self];
    
      [self.jsBridge postNotificationName:@"setScreenHeight" userInfo:[NSDictionary dictionaryWithObjectsAndKeys:[NSString stringWithFormat:@"%f",screenHeight],@"message", nil] toWebView:self];
    
}
-(void)setPlacementType
{
    [self.jsBridge postNotificationName:@"setPlacementType" userInfo:[NSDictionary dictionaryWithObjectsAndKeys:placementType,@"message", nil] toWebView:self];
}
-(void)setStateType
{
    [self.jsBridge postNotificationName:@"setStateType" userInfo:[NSDictionary dictionaryWithObjectsAndKeys:stateType,@"message", nil] toWebView:self];
}
-(void)setMaxSize
{
    [self.jsBridge postNotificationName:@"setMaxSizeWidth" userInfo:[NSDictionary dictionaryWithObjectsAndKeys:[NSString stringWithFormat:@"%f",view.frame.size.width],@"message", nil] toWebView:self];
    
    [self.jsBridge postNotificationName:@"setMaxSizeHeigth" userInfo:[NSDictionary dictionaryWithObjectsAndKeys:[NSString stringWithFormat:@"%f",view.frame.size.height],@"message", nil] toWebView:self];
}





//MRAID 2.0 methods

-(void)expand{
    if ([stateType isEqualToString:@"default"] || [stateType isEqualToString:@"resized"]) {
        [closeButton removeFromSuperview];
        self.layer.zPosition=MAXFLOAT;      //view always on top
        [UIView animateWithDuration:1
                              delay:0
                            options: UIViewAnimationCurveEaseOut
                         animations:^{
                             
                             if (expandProperties.width==0 || expandProperties.height==0) {
                                 [[view.window.subviews objectAtIndex:0]addSubview:self];
                                 
                                 [self setFrame:screenSize];
                              
                             }
                             else
                             {
                                 [[view.window.subviews objectAtIndex:0]addSubview:self];
                                 [self setFrame:CGRectMake(0, 0, expandProperties.width, expandProperties.height)];
                             }
         
                        }
         
                         completion:^(BOOL finished){
                             stateType=@"expanded";
                             [self setStateType];
                            
                             if (expandProperties.useCustomClose) {
                                closeButton=[[UIButton alloc]initWithFrame:CGRectMake(self.frame.size.width-25, 0, 25, 25)];
                                 [closeButton addTarget:self action:@selector(close) forControlEvents:UIControlEventTouchUpInside];
                                 [closeButton setImage:[UIImage imageNamed:@"close.png"] forState:UIControlStateNormal];
                                 [self addSubview:closeButton];
                                 
                             }
                             
                         }
         ];
    }
   
}
-(void)addEventListener{
    
}
-(void)createCalendarEvent{
    
    
}
-(void)close{
    [closeButton removeFromSuperview];
    if ([stateType isEqualToString:@"default"]) {
        [self removeFromSuperview];
        stateType=@"hidden";
        [self setStateType];
    }
    else if ([stateType isEqualToString:@"expanded"] || [stateType isEqualToString:@"resized"])
{
    [UIView animateWithDuration:0.5
                          delay:0
                        options: UIViewAnimationCurveEaseOut
                     animations:^{
                         [view addSubview:self];
                         [self setFrame:defaultPosition];
                         
                     }
                     completion:^(BOOL finished){
                         stateType=@"default";
                         [self setStateType];
                         self.layer.zPosition=0;      //view always on top
                     }
     ];
    
   
}
   

}
-(void)getCurrentPosition{
    
}
-(void)getDefaultPosition{
    
}
-(void)getExpandProperties{
    
}
-(void)getMaxSize{
    
}
-(void)getPlacementType{
    
}
-(void)getResizeProperties{
    
}
-(void)getScreenSize{
    
}
-(void)getState{
    
}
-(void)getVersion{
    
}
-(void)isViewable{
    
}
-(void)open{
    
}
-(void)playVideo{
    
}
-(void)removeEventListener{
    
}
-(void)selfExpandProperties{
    
}
-(void)setResizeProperties{
    
}
-(void)storePictureWithString:(NSString*)string{
    
    UIAlertView * alert=[[UIAlertView alloc]initWithTitle:@"Image downloading" message:@"Do you want to download image?" delegate:self cancelButtonTitle:@"NO" otherButtonTitles:@"YES", nil];
    [alert show];
    
    NSURLRequest *request = [NSURLRequest requestWithURL:[NSURL URLWithString:string] cachePolicy:NSURLCacheStorageNotAllowed timeoutInterval:10.0];
    [NSURLConnection sendAsynchronousRequest:request queue:[NSOperationQueue mainQueue] completionHandler:^(NSURLResponse *response, NSData *data, NSError *err){
        if (!err && data) {
            UIImage * image=[UIImage imageWithData:data];
            UIImageWriteToSavedPhotosAlbum(image, nil, nil, nil);
        }
    }];
    
 
    
}
- (void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex
{
    if (buttonIndex==0) {
        //blad
    }
        else
        {
            
        }
    
}


-(void)supports{
    
}
-(void)useCustomClose{
    
}
-(void)resize{
    if (resizeProperties.width==0 ||
        resizeProperties.height==0) {
        
        //error!!!
    }
    else
    {
    if ([stateType isEqualToString:@"default"]) {
        
        [UIView animateWithDuration:1
                              delay:0
                            options: UIViewAnimationCurveEaseOut
                         animations:^{
                             
                             
                             
                                 [self setFrame:CGRectMake(resizeProperties.offsetX,
                                                           resizeProperties.offsetY,
                                                           resizeProperties.width,
                                                           resizeProperties.height)];
                             
                             
                         }
                         completion:^(BOOL finished){
                             stateType=@"resized";
                             [self setStateType];
                             
                             if ([resizeProperties.customClosePosition isEqualToString:@"top-left"]) {
                                 closeButton=[[UIButton alloc]initWithFrame:CGRectMake(0, 0, 25, 25)];
                                 
                             }
                             else if ([resizeProperties.customClosePosition isEqualToString:@"top-right"])
                             {
                                closeButton=[[UIButton alloc]initWithFrame:CGRectMake(self.frame.size.width-25, 0, 25, 25)];
                             }
                             else if ([resizeProperties.customClosePosition isEqualToString:@"center"])
                             {
                                 closeButton=[[UIButton alloc]initWithFrame:CGRectMake(self.frame.size.width/2, self.frame.size.height/2, 25, 25)];
                             }else if ([resizeProperties.customClosePosition isEqualToString:@"bottom-left"])
                             {
                                 closeButton=[[UIButton alloc]initWithFrame:CGRectMake(0, self.frame.size.height-25, 25, 25)];
                             }else if ([resizeProperties.customClosePosition isEqualToString:@"bottom-right"])
                             {
                                 closeButton=[[UIButton alloc]initWithFrame:CGRectMake(self.frame.size.width-25, self.frame.size.height-25, 25, 25)];
                             }else if ([resizeProperties.customClosePosition isEqualToString:@"top-center"])
                             {
                                 closeButton=[[UIButton alloc]initWithFrame:CGRectMake(self.frame.size.width/2, 0, 25, 25)];
                             }else if ([resizeProperties.customClosePosition isEqualToString:@"bottom-center"])
                             {
                                 closeButton=[[UIButton alloc]initWithFrame:CGRectMake(self.frame.size.width/2, self.frame.size.height-25, 25, 25)];
                             }
                             else
                             {
                                 closeButton=[[UIButton alloc]initWithFrame:CGRectMake(self.frame.size.width-25, 0, 25, 25)];
                             }
                             
                             
                             [closeButton addTarget:self action:@selector(close) forControlEvents:UIControlEventTouchUpInside];
                             [closeButton setImage:[UIImage imageNamed:@"close.png"] forState:UIControlStateNormal];
                             [self addSubview:closeButton];
                             
                             }
                             
                         
         ];
    }
        
    }
}

-(void)ready
{
    
}
@end
